//д IF-free sorting.cpp : Defines the entry point for the console
// (C) 2013-2014 Evgeney Knyazhev
// app name: IF-free Alg0Z(FSORT)
#define __STDC_CONSTANT_MACROS 1
#define PVT2 1
#define PVT1 0
#define RND_PVT 2
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include <time.h>
#include <stdbool.h>
#include </usr/include/c++/4.8/iostream>     // std::cout
#include </usr/include/c++/4.8/algorithm>    // std::make_heap, std::pop_heap, std::push_heap, std::sort_heap
#include <vector>       // std::vector
#include <cmath>
#include <unistd.h>
#include <signal.h>
#include <errno.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/resource.h>
#pragma GCC diagnostic ignored "-fpermissive"
using namespace std;
int get_pivotVerII(void);
int get_pivotVerI(void);
//__private_extern__
void
qs0(void *a, size_t n, size_t es, int (*cmp)(const void *, const void *));

static inline char	*med3(char *, char *, char *, int (*)(const void *, const void *));
static inline void	 swap0func(char *, char *, int, int);
#define min(a, b)	(a) < (b) ? a : b

/*
 * Qsort routine from Bentley & McIlroy's "Engineering a Sort Function".
 */
#define swap0code(TYPE, parmi, parmj, n) { 		\
	long i = (n) / sizeof (TYPE); 			\
	TYPE *pi = (TYPE *) (parmi); 			\
	TYPE *pj = (TYPE *) (parmj); 			\
	do { 						\
		TYPE	t = *pi;			\
		*pi++ = *pj;				\
		*pj++ = t;				\
        } while (--i > 0);				\
}

#define SWAPINIT(a, es) swap0type = ((char *)a - (char *)0) % sizeof(long) || \
	es % sizeof(long) ? 2 : es == sizeof(long)? 0 : 1;

static inline void
swap0func(char *a, char *b, int n, int swap0type)
{
	if(swap0type <= 1) 
		swap0code(long, a, b, n)
	else
		swap0code(char, a, b, n)
}

#define swap0(a, b)					\
	if (swap0type == 0) {				\
		long t = *(long *)(a);			\
		*(long *)(a) = *(long *)(b);		\
		*(long *)(b) = t;			\
	} else						\
		swap0func((char*)a, (char*)b, es, swap0type)

#define vecswap0(a, b, n) 	if ((n) > 0) swap0func((char*)a, (char*)b, n, swap0type)

static inline char *
med3(char *a, char *b, char *c, int (*cmp)(const void *, const void *))
{
	return cmp(a, b) < 0 ?
	       (cmp(b, c) < 0 ? b : (cmp(a, c) < 0 ? c : a ))
              :(cmp(b, c) > 0 ? b : (cmp(a, c) < 0 ? a : c ));
}

//__private_extern__
void
qs0(void *a, size_t n, size_t es, int (*cmp)(const void *, const void *))
{
	char *pa, *pb, *pc, *pd, *pl, *pm, *pn;
	int d, swap0type, swap0_cnt;
	int r;

loop0:	SWAPINIT(a, es);
	swap0_cnt = 0;
	if (n < 7) {
		for (pm = (char *)a + es; pm < (char *) a + n * es; pm += es)
			for (pl = pm; pl > (char *) a && cmp(pl - es, pl) > 0;
			     pl -= es)
				swap0(pl, pl - es);
		return;
	}
	pm = (char *)a + (n / 2) * es;
	if (n > 7) {
		pl = (char*)a;
		pn = (char *)a + (n - 1) * es;
		if (n > 40) {
			d = (n / 8) * es;
			pl = med3(pl, pl + d, pl + 2 * d, cmp);
			pm = med3(pm - d, pm, pm + d, cmp);
			pn = med3(pn - 2 * d, pn - d, pn, cmp);
		}
		pm = med3(pl, pm, pn, cmp);
	}
	swap0(a, pm);
	pa = pb = (char *)a + es;

	pc = pd = (char *)a + (n - 1) * es;
	for (;;) {
		while (pb <= pc && (r = cmp(pb, a)) <= 0) {
			if (r == 0) {
				swap0_cnt = 1;
				swap0(pa, pb);
				pa += es;
			}
			pb += es;
		}
		while (pb <= pc && (r = cmp(pc, a)) >= 0) {
			if (r == 0) {
				swap0_cnt = 1;
				swap0(pc, pd);
				pd -= es;
			}
			pc -= es;
		}
		if (pb > pc)
			break;
		swap0(pb, pc);
		swap0_cnt = 1;
		pb += es;
		pc -= es;
	}
	if (swap0_cnt == 0) {  /* Switch to insertion sort */
		for (pm = (char *)a + es; pm < (char *) a + n * es; pm += es)
			for (pl = pm; pl > (char *) a && cmp(pl - es, pl) > 0; 
			     pl -= es)
				swap0(pl, pl - es);
		return;
	}

	pn = (char *)a + n * es;
	r = min(pa - (char *)a, pb - pa);
	vecswap0(a, pb - r, r);
	r = min((size_t)(pd - pc), pn - pd - es);
	vecswap0(pb, pn - r, r);
	if ((size_t)(r = pb - pa) > es)
		qs0(a, r / es, es, cmp);
	if ((size_t)(r = pd - pc) > es) { 
		/* Iterate rather than recurse to save stack space */
		a = pn - r;
		n = r / es;
		goto loop0;
	}
	qs0(pn - r, r / es, es, cmp);
}
/* End
 * Qsort routine from Bentley & McIlroy's "Engineering a Sort Function".
 */
#define handle_error(msg) \
           do { perror(msg); exit(EXIT_FAILURE); } while (0)

static void
       handler(int sig, siginfo_t *si, void *unused)
       {
           printf("Got SIGSEGV at address: 0x%lx\n",
                   (long) si->si_addr);
           exit(EXIT_FAILURE);
       }
void modExp(uint64_t mod, int64_t *seed, uint64_t exp)
{
  int root = 1;
  int64_t lseed = *seed;

  for(int i = 0; exp >> (i + 1) > 0; i++)
  {
    if(((exp >> i) & 1) == 1)
    {
      root *= lseed;
      root %= mod;
    }
    lseed = (lseed * lseed) % mod;
  }
  *seed = root;
  return;
}
struct ADR;
//typedef int (*LOADS)(ADR *adr);
//typedef void (*SWAPS)(double*, double*);
typedef int (*LOADS)();
typedef void (*SWAPS)();
typedef int (*FSORTS)(double*, double*, int);
typedef void (*NAS)();
struct ADR{
	double *fst0;
	double *lst0;
	double *fst;
	double *lst;
	double *arr;
	double *parr;
	LOADS loadL[2];
	LOADS loadR[2];
	SWAPS swp[8];
	NAS nas[2];
	LOADS getpivot[3];
	int LNotSorted;
	int RNotSorted;
	int64_t ESP;
	int64_t EBP;
	int cnt;
	char wing;
	}adrLR;
	struct guideVal{
		double pivotCorrection;
		SWAPS swp;
		LOADS adj_pvt[2];
		FSORTS fsort[2];
		int depth;
		int flgSWP;
		bool swtch;
	}GV0;
	struct constants{
		int64_t  fffffffffffffff8;//ff ff ff ff ff ff ff f8: align adr offset
		int64_t  ffffffff00000000;//ff ff ff ff 00 00 00 00: mask to search mostleft "1"
		int64_t h000fffffffffffff;//00 0f ff ff ff ff ff ff: mask to select significands
		int64_t h00000000000007ff;//00 00 00 00 00 00 07 ff: mask to recover exponent
		int64_t range;
		int64_t rnd;
		}consts;
void pseudoRND_fast(int64_t *arr, int num0fItems, int64_t mod, int64_t seed, int64_t exp){
	uint64_t dnMask=0x800FFFFFFFFFFFFFLL;// mask to generate denormals
	uint64_t mask2selDn=0x3;//mask to select number to become denormal
	uint64_t nan =  0x7fffffff00005001LL;
	uint64_t noNan=0xFFEFFFFFFFFFFFFFLL;//const to exclude nans
	//srand (time(NULL)*seed);
	 __asm__ (
		 "movlpd %[mod],  %%xmm0; \n\t"
		 "movlpd %[exp],  %%xmm1;\n\t"
		 "movlpd %[seed], %%xmm2; \n\t"
		 "movlpd %[dnMask], %%xmm5; \n\t"
		 "movlpd %[mask2selDn], %%xmm6; \n\t"
		 "movq %[arr], %%rdx; \n\t"
		 "movl %[num0fItems], %%ecx; \n\t"
		 "mov  $2, %%rdi; \n\t"
		 "movq $0x8, %%rax; \n\t"
		 "lea (, %%rcx, 0x8), %%rcx; \n\t"
		 "add %%rcx, %%rdx; \n\t"
		 "xorq %%rbx, %%rbx; \n\t"// Zero
		 "jmp firstly; \n\t"
		 "mix:                        ; \n\t"
		  "sub %%rax, %%rdx;             \n\t"
		  "sub %%rax, %%rcx;            \n\t"
		 "firstly:                    ; \n\t"
		 "pshufd $0xe4, %%xmm0, %%xmm3; \n\t"
		 "pshufd $0xe4, %%xmm1, %%xmm4; \n\t"
		 //mod mix
		 "paddq %%xmm3, %%xmm1; \n\t"
         "psllq $22, %%xmm3; \n\t"
		 "paddq %%xmm3, %%xmm1; \n\t"
		 "psllq $31, %%xmm3; \n\t"
		 "paddq %%xmm3, %%xmm1; \n\t"
		 //mod mix
		
		 //exp mix
		 "paddq %%xmm4, %%xmm0; \n\t"
         "psllq $23, %%xmm4; \n\t"
		 "paddq %%xmm4, %%xmm0; \n\t"
		 "psllq $31, %%xmm4; \n\t"
		 "paddq %%xmm4, %%xmm0; \n\t"
		 //exp mix
		 
		 //seed mix
		 "paddq %%xmm0, %%xmm2; \n\t"
         "pshuflw $0x1B, %%xmm2, %%xmm2; \n\t"//shufle -- 00 01 10 11b
		 "pxor %%xmm2, %%xmm1; \n\t"
		 "pmulhw %%xmm2, %%xmm0; \n\t"
		 "paddq %%xmm0, %%xmm2; \n\t"
		 //seed mix
		 "pshufd $0xe4, %%xmm2, %%xmm7; \n\t"
		 "pand %%xmm6, %%xmm7; \n\t"
		 "movq %%xmm6, %%rsi; \n\t"
		 "movq %%rdi, %%xmm6; \n\t"
		 "CMPSD $0, %%xmm6,%%xmm7 \n\t"
		 "psrlq %%xmm7,%%xmm5; \n\t"//if xmm7 == 0xFF(8), dnMask == 0
		 "por %%xmm5, %%xmm7; \n\t"
		 "movq %%rsi, %%xmm6; \n\t"
		 "movlpd %[dnMask], %%xmm5; \n\t"
		 "pand %%xmm2, %%xmm7; \n\t"
		 //"movlpd %[nan], %%xmm7; \n\t"
		 "movlpd %[noNan], %%xmm1; \n\t"
		 "pand %%xmm1, %%xmm7; \n\t"
		/* //////////////temp////////////
		 "mov  $38, %%rdi        ; \n\t"
		 "movq %%rdi, %%xmm7; \n\t"
	     "CVTDQ2PD %%xmm7, %%xmm7; \n\t"
		 //////////temp////////*/
		 "movlpd %%xmm7, (%%rdx); \n\t"
		 "zero: cmp %%rbx, %%rcx; \n\t"
		 "jnz mix; \n\t"
		 /* "movlpd %[nan], %%xmm5; \n\t"
		   "mov  $8, %%rax; \n\t"
		  "mov  %%rdx, %%rax; \n\t"
		  "movlpd %%xmm5, (%%rax); \n\t"*/
		: [mod]"=m"(mod), [exp]"=m"(exp), [seed]"=m"(seed), [dnMask]"=m"(dnMask), [mask2selDn]"=m"(mask2selDn), [nan]"=m"(nan), [noNan]"=m"(noNan), \
           [num0fItems]"=m"(num0fItems), [arr]"=m"(adrLR.arr) //output
		:// "c"(num0fItems), "d"(arr)                                                                           //input
		:                                                                                                    //clobbered
	);
	}
void pseudoRND(int64_t *arr, int num0fItems, int64_t mod, int64_t seed,
int64_t exp)
{
  int size0fT1 = sizeof(int64_t) * 8 - 1;
  int64_t sign = 0;

  for(int i = 0; i < num0fItems; i++)
  {
get_new_rand_val:  modExp(mod, &seed, exp);
    //sign = (seed >> size0fT1);
	
    arr[i] = seed;
	if(arr[i]<0)arr[i]*=-1;
	if(!isnormal((double)arr[i]))goto get_new_rand_val;
		
  }
}

#define chosenT  int64_t

/*********************** NO-IF HeapSort ********************************/
 uint64_t msk=(1LLU<<63)-1LLU+(1LLU<<63), msk0, msk1, msk2;
 int64_t empty, *pEmpty, i1, i2, *p0, *p1;
extern inline void swp(double *p0, double *p1);
inline void swp(double *p0, double *p1)
{
  double empty;
  empty = *p0;
  *p0 = *p1;
  *p1 = empty;
  return;
}

int64_t le(int64_t *p0, int64_t *p1, unsigned char flg)
{
  int64_t empty, i1, i2;
  uint64_t mask=(1LLU<<63)-1LLU+(1LLU<<63), msk1, msk2;
  /* unsigned char flg;
  i1 = *p0 - *p1;
  __asm__ (
		//"mov  $0, %%rax; \n\t"
        "lahf; \n\t"
//        "and $0x80, %%ah; \n\t" 
		"shrb $7, %%ah; \n\t"
		"movb %%ah, %0 \n\t"
		: "=m"(flg)
		: //input
		: //"%eax"
	);*/
	i2=flg;
  i1 = (i2 + 1) & 1;
  empty = *p0;
 // *p1=1LL<<37;//UINT64_C(1<<37);
  //*p0=(int64_t)(*p1>>33);
  msk2=mask+i2;
  msk1=mask+i1;
  *p0&=msk2;
  *p0+=*p1 & msk1;//(int64_t)((int64_t)(*p0>>i2)+(int64_t)(*p1>>i1));
  *p1&=msk2;
  *p1+=empty & msk1;
  return i1;
}
extern inline void swap(int64_t *a, int first, int second);
extern int siftDown_sse2(double *a, int root, int32_t end);
int siftDown_sse2(double *a, int root, int32_t end)
{
  int child;
  int count = 0;
  int64_t dv;
  int indx=0;
  int32_t setEnd[2];
  int64_t *p01[2], *p11[2];
  p01[0]=pEmpty;
  p11[0]=pEmpty;
  setEnd[0]=0;
  setEnd[1]=end;
  /*unsigned*/ char flg;
  child = root << 1;
  child++;
  clock_t start, stop;
   __asm__ (
         "movq %0, %%rbx; \n\t"
		 "movq %1, %%rdx; \n\t"
		 //"movq %2, %%rcx; \n\t"
		 //"leal (, %%rcx, 0x8), %%rcx; \n\t"
		 "leaq (, %%rdx, 0x8), %%rdx; \n\t"
		"leaq (%%rbx, %%rdx, ), %%rax; \n\t"
		"movq (%%rax), %%xmm0; \n\t"
		: //output
		: "m"(a), "m"(root), "m"(end)//input
		: "%ebx", "%edx", "%ecx"
	);
  
		// while(child < end)
  //{
	    __asm__ (
         "lea 8(%%rbx, %%rdx, 2), %%rax; \n\t" //load a[child], child==2*root+1
		 "movapd (%%rax), %%xmm1; \n\t"
		 "PSHUFD $0x4e, %%xmm1, %%xmm2; \n\t"
		 "comisd %%xmm0, %%xmm1; \n\t"
		 "lahf; \n\t"
		 "and %%rax, 1; \n\t"
		 "maxsd %%xmm1, %%xmm2; \n\t"
		 "minpd %%xmm1, %%xmm2; \n\t"
		 
		: //output
		: //"m"(a), "m"(root)//input
		: //clobbered
	);
  //}
}

int Heapify(double *a, int end)
{
  int root = (end-1)/2;
  int cnt = 0;
  while(root > -1)
  {
siftDown_sse2(a, root, end);
root--;
  }
  return cnt;
}

int heapSort(double *arr, int end)
{
  int latency=0;
  clock_t start, stop;
  int count = Heapify(arr, end-1);
  while(end > 0)
  {
    swp(&arr[0], &arr[end]);
	//start=clock();
    latency+=siftDown_sse2(arr, 0, end-1);
	/*stop=clock();
	stop-=start;
	latency+=stop;*/
    end--;
  }
  //printf("latency (%f msec)\n", (1000.0*latency/CLOCKS_PER_SEC));
  return count;
}
/*********************** NO-IF HeapSort ********************************/
/*********************** NO-IF QSort-based ****************************/
double register *adrLRlst0 asm("%r8");
double register *adrLRfst0 asm("%r9");
int fsortL_stub(double*, double*, int){
	__asm__ (
	   //  "movq $0, %%rax; \n\t"
		 "popq %%rbp; \n\t"
		 "retq; \n\t"
		://output
		:  //input
		: //clobbered
	);}
int fsortR_stub(double*, double*, int){
	__asm__ (
	     //"movq $0, %%rax; \n\t"
		 "popq %%rbp; \n\t"
		 "retq; \n\t"
		://output
		:  //input
		: //clobbered
	);}
void  __attribute__((aligned(8192)))
 ok(){
	__asm__ (
	          //"add $8, %%r8; \n\t"
		 //"sub $8, %%r9; \n\t"
		 
		"add %%r10, %%r8 ; \n\t"
		"sub %%r10, %%r9 ; \n\t"
		 "movq (%%r8), %%xmm1; \n\t"
		 "movq (%%r9), %%xmm2; \n\t"
		 "popq %%rbp; \n\t"
		 "retq; \n\t"
		://output
		:  //input
		: //clobbered
	);}
void  //__attribute__((aligned(4)))
swpnLL(){ // swap & load left item to xmm1
     __asm__ (
      // "PSHUFD $0xE4, %%xmm1, %%xmm0; \n\t"
	    "movq %%xmm1, (%%r9); \n\t"
		"movq %%xmm2, (%%r8); \n\t"
		"minsd %%xmm1, %%xmm2; \n\t"
		"add %%r10, %%r8; \n\t"
		"movq (%%r8), %%xmm1; \n\t"
		"prefetcht1 0x8(%%r8); \n\t"
		/*"lload:               ; \n\t"
		"PSHUFD $0xE4, %%xmm0, %%xmm7; \n\t"
		 /*********** xmm0 < xmm1 ////////////
		 "CMPSD $1, %%xmm1,%%xmm7 \n\t" // test xmm0 <= xmm1
		 "movdq2q %%xmm7, %%mm4 \n\t"//moves the result of comparison to var (mm4)
		 "PSHUFW $0xE4, %%mm1, %%mm0; \n\t"// saves prev. value of flag LNotSorted
		 "por %%mm4, %%mm1 \n\t"// updates flag LNotSorted. if flag equals zero, then all items in subset are well-ordered -- greater than 0 means otherwise
		 /*********** xmm0 < xmm1 **********/
		:                 //output
		:                 //input
		:                //clobbered
	);
	return;
	}
void  //__attribute__((aligned(4)))
swpnLR(){ //swap & load right item to xmm2
      
	  __asm__ (
       // "movq %1, %%rax; \n\t"
		//"PSHUFD $0xE4, %%xmm2, %%xmm3; \n\t" // copy xmm2 (previous item ) to xmm3
		"movq %%xmm1, (%%r9); \n\t"
		"movq %%xmm2, (%%r8); \n\t"
		"maxsd %%xmm2, %%xmm1; \n\t"
		"sub    %%r10,    %%r9 ; \n\t"
		"movq (%%r9), %%xmm2; \n\t" // load next item from array
		"prefetcht1 -0x8(%%r9); \n\t"
		/*"rload: PSHUFD $0xE4, %%xmm2, %%xmm7; \n\t"
		 /*********** xmm2 > xmm3 ///////////
		 "CMPSD $1, %%xmm3,%%xmm7 \n\t" // test xmm2 <= xmm3
		 "movdq2q %%xmm7, %%mm4 \n\t"//
		 "PSHUFW $0xE4, %%mm2, %%mm3; \n\t"// saves prev. value of flag RNotSorted
		 "por %%mm4, %%mm2 \n\t"
		 /*********** xmm2 > xmm3 **********/
		://output
		://input
		://clobbered
	);
	return;
	}
void  //__attribute__((aligned(4))) 
load_L(){ // load left item to xmm1
      // adrLRlst0+=1;
     __asm__ (
          "add %%r10, %%r8; \n\t"
		"movq (%%r8), %%xmm1; \n\t"
		"prefetcht1 0x8(%%r8); \n\t"
		"pop %%rbp          ; \n\t"
		"ret                 ; \n\t"
		/*"lload:               ; \n\t"
		"PSHUFD $0xE4, %%xmm0, %%xmm7; \n\t"
		 /*********** xmm0 < xmm1 ////////////
		 "CMPSD $1, %%xmm1,%%xmm7 \n\t" // test xmm0 <= xmm1
		 "movdq2q %%xmm7, %%mm4 \n\t"//moves the result of comparison to var (mm4)
		 "PSHUFW $0xE4, %%mm1, %%mm0; \n\t"// saves prev. value of flag LNotSorted
		 "por %%mm4, %%mm1 \n\t"// updates flag LNotSorted. if flag equals zero, then all items in subset are well-ordered -- greater than 0 means otherwise
		 /*********** xmm0 < xmm1 **********/
		:                 //output
		:// "a"(adrLRlst0)//input
		:                //clobbered
	);
	//return;
	}
void  //__attribute__((aligned(4)))
load_R(){ // load right item to xmm2
        //adrLRfst0-=1;
	  __asm__ (
                  "sub %%r10, %%r9; \n\t"
		//"PSHUFD $0xE4, %%xmm2, %%xmm3; \n\t" // copy xmm2 (previous item ) to xmm3
		"movq (%%r9), %%xmm2; \n\t" // load next item from array
		"prefetcht1 -0x8(%%r9); \n\t"
		"pop %%rbp           ; \n\t"
		"ret                ; \n\t"
		/*"rload: PSHUFD $0xE4, %%xmm2, %%xmm7; \n\t"
		 /*********** xmm2 > xmm3 ///////////
		 "CMPSD $1, %%xmm3,%%xmm7 \n\t" // test xmm2 <= xmm3
		 "movdq2q %%xmm7, %%mm4 \n\t"//
		 "PSHUFW $0xE4, %%mm2, %%mm3; \n\t"// saves prev. value of flag RNotSorted
		 "por %%mm4, %%mm2 \n\t"
		 /*********** xmm2 > xmm3 **********/
		://output
		: //"a"(adrLRfst0) //input
		: //clobbered
	);
	//return;
	}
void  //__attribute__((aligned(4)))
 xorswap(){
		 __asm__ (
		/*"pxor %%xmm1, %%xmm2; \n\t"
		"pxor %%xmm2, %%xmm1; \n\t"
		"pxor %%xmm1, %%xmm2; \n\t"
		/*"pshufd $0xe4, %%xmm1, %%xmm7; \n\t"
		"pshufd $0xe4, %%xmm2, %%xmm1; \n\t"
		"pshufd $0xe4, %%xmm7, %%xmm2; \n\t"*/
		//"mov  $8,   %%r15; \n\t"
		"movq %%xmm1, (%%r9); \n\t"
		"movq %%xmm2, (%%r8); \n\t"
		"add %%r10, %%r8 ; \n\t"
		"sub %%r10, %%r9 ; \n\t"
		"movq (%%r8), %%xmm1; \n\t"
		"movq (%%r9), %%xmm2; \n\t"
		://output
		://"r"(adrLRlst0), "r"(adrLRfst0)//input
		://clobbered
	);
	}
int load_stub(){
	__asm__ (
	   //  "movq $0, %%rax; \n\t"
		 "popq %%rbp; \n\t"
		 "retq; \n\t"
		://output
		:  //input
		: //clobbered
	);}
void nas_stub(){
	__asm__ (
	 //    "movq $1, %%rax; \n\t"
		 "popq %%rbp; \n\t"
		 "retq; \n\t"
		://output
		:  //input
		: //clobbered
	);}// nas == normalize after swap
void swap_stub(){
	__asm__ (
	  //   "movq $1, %%rax; \n\t"
		 "popq %%rbp; \n\t"
		 "retq; \n\t"
		://output
		:  //input
		: //clobbered
	);}
void normalize_after_swap_R(){
	 __asm__ (
	     "PSHUFD $0xE4, %%xmm2, %%xmm7; \n\t"
		 /*********** xmm2 > xmm3 **********/
		 "CMPSD $1, %%xmm3,%%xmm7 \n\t" // test xmm2 > xmm3
		 "movdq2q %%xmm7, %%mm4 \n\t"//
		 "PSHUFW $0xE4, %%mm3, %%mm2; \n\t"//
		 "por %%mm4, %%mm2 \n\t"
		 /*********** xmm2 > xmm3 **********/
		:                       //output
		:  //input
		: //clobbered
	);

		}
	void normalize_after_swap_L(){
	 __asm__ (
		 "PSHUFD $0xE4, %%xmm0, %%xmm7; \n\t"
		 /*********** xmm0 < xmm1 **********/
		 "CMPSD $1, %%xmm1,%%xmm7 \n\t" // test xmm0 < xmm1
		 "movdq2q %%xmm7, %%mm4 \n\t"//moves the result of comparison to var (mm4)
		 "PSHUFW $0xE4, %%mm0, %%mm1; \n\t"// sets prev. value of flag LNotSorted
		 "por %%mm4, %%mm1 \n\t"// recalculates flag LNotSorted from its prev. value. if flag equals zero, then all items in subset are well-ordered -- greater than 0 means otherwise
		 
		 /*********** xmm0 < xmm1 **********/
		:                       //output
		:                      //input
		: //clobbered
	);

		}
	void normalize_after_swap(){
	 __asm__ (
		"PSHUFD $0xE4, %%xmm2, %%xmm7; \n\t"
		 /*********** xmm2 > xmm3 **********/
		 "CMPSD $1, %%xmm3,%%xmm7 \n\t" // test xmm2 > xmm3
		 "movdq2q %%xmm7, %%mm4 \n\t"//
		 "PSHUFW $0xE4, %%mm3, %%mm2; \n\t"//
		 "por %%mm4, %%mm2 \n\t"
		 /*********** xmm2 > xmm3 **********/
		 
		"PSHUFD $0xE4, %%xmm0, %%xmm7; \n\t"
		 /*********** xmm0 < xmm1 **********/
		 "CMPSD $1, %%xmm1,%%xmm7 \n\t" // test xmm0 < xmm1
		 "movdq2q %%xmm7, %%mm4 \n\t"//moves the result of comparison to var (mm4)
		  "PSHUFW $0xE4, %%mm0, %%mm1; \n\t"// sets previous value of flag LNotSorted
		 "por %%mm4, %%mm1 \n\t"// recalculates flag LNotSorted from its prev. value. if flag equals zero, then all items in subset are well-ordered -- greater than 0 means otherwise
		 /*********** xmm0 < xmm1 **********/
		:// "=m"(adrLR.LNotSorted),  "=m"(adrLR.RNotSorted)//output
		: //"b"(adrLR.LNotSorted), "d"(adrLR.RNotSorted) //input
		:// "ebx", "edx"//clobbered
	);

		}

int load_L_once(){ // runs once, then changes self to load_L()
 //  	adrLR.loadL[0]=&load_L;
	/*if(adrLR.nas[0]!=adrLR.nas[1])adrLR.nas[1]=&normalize_after_swap;
	else adrLR.nas[1]=&normalize_after_swap_L;*/
	  int retq;
	   adrLRlst0+=1;
     __asm__ (
	//   "PSHUFD $0xE4, %%xmm1, %%xmm0; \n\t"//
       "movq (%%rax), %%xmm1; \n\t"
	   "prefetcht1 0x8(%%rax); \n\t"
	  /* "lload0: PSHUFD $0xE4, %%xmm0, %%xmm7; \n\t"
		 /************ xmm0 < xmm1 /////////////
		 "CMPSD $1, %%xmm1,%%xmm7 \n\t" // test xmm0 <= xmm1
		 "movdq2q %%xmm7, %%mm4 \n\t"//moves the result of comparison to var (mm4)
		 "PSHUFW $0xE4, %%mm1, %%mm0; \n\t"// saves prev. value of flag LNotSorted
		 "por %%mm4, %%mm1 \n\t"// updates flag LNotSorted. if flag equals zero, then all items in subset are well-ordered -- greater than 0 means otherwise
		 /*********** xmm0 < xmm1 **********/
		: //output
		: "a"(adrLRlst0)//input
		:                //clobbered
	);
	return retq;
	}
	int load_R_once(){ // runs once, then changes self to load_R()
	  int retq; 
   //	  adrLR.loadR[0]=&load_R;
	  /*if(adrLR.nas[0]!=adrLR.nas[1])adrLR.nas[1]=&normalize_after_swap;
	  else adrLR.nas[1]=&normalize_after_swap_R;*/
	  adrLRfst0-=1;
	__asm__ (
       // "movq %1, %%rax; \n\t"
	   //"PSHUFD $0xE4, %%xmm2, %%xmm3; \n\t" // copy xmm2 (previous item ) to xmm3
	   "prefetcht1 0x8(%%rax); \n\t"
	   "movq (%%rax), %%xmm2; \n\t" // load next item from array
	   /*"rload0: PSHUFD $0xE4, %%xmm2, %%xmm7; \n\t"
		 /*********** xmm2 < xmm3 ////////////
		 "CMPSD $1, %%xmm3,%%xmm7 \n\t" // test xmm2 <= xmm3
		 "movdq2q %%xmm7, %%mm4 \n\t"//
		 "PSHUFW $0xE4, %%mm2, %%mm3; \n\t"// saves prev. value of flag RNotSorted
		 "por %%mm4, %%mm2 \n\t"
		 /*********** xmm2 < xmm3 **********/
		://output
		: "a"(adrLRfst0) //input
		: //clobbered
	);
	return retq;
	}


int get_pivotVerI();
int get_pivotVerII_wnod(){ // version doesn't process denormals
	int64_t sum;
	int64_t counter;
	int flagToFormPivot;
	int AllExponentsAreEqual;
	//////////////////////////// compute middle element //////////////////
		__asm__ (
		"xorq %%rdi, %%rdi; \n\t"// esi is var to configure the indicator[binary flags in edi] whether array has positive/negative vals.
		"xorq %%rdx, %%rdx; \n\t" // clear the counter
		"movq $0x1, %%rbx; \n\t" // set unit to increase counter
		"pcmpeqw %%xmm6, %%xmm6; \n\t"// is flag to whether all exponents are equal each other in given set
		"PSHUFD $0x44, %%xmm6, %%xmm3; \n\t"// xmm3 stores flag to complete 1st run
		// put "1023" const in the low int64
		 "pcmpeqw %%xmm5, %%xmm5; \n\t"// xmm5 is bias
         "psrlq $53, %%xmm5 ; \n\t"
		 "PSHUFD $0x44, %%xmm5, %%xmm2; \n\t" // set the mask for exponent
		 "psrlq $1, %%xmm5 ; \n\t"
		 // put "1023" const in the bottom int64
		 "xorpd %%xmm4, %%xmm4; \n\t"
		 "jmp fst_run0; \n\t"
		 "ADD0: PSHUFD $0x44, %%xmm1, %%xmm3; \n\t"// loads previous item
         "add $0x8, %%rax; \n\t"// pointer to next item
		 "fst_run0: movq (%%rax), %%xmm1; \n\t" // loads current item
		 "psrlq $0x34, %%xmm1; \n\t" // gets exponent & sign bit as well
		 "movq %%xmm1, %%rsi; \n\t"//..
		 "shrq $0xb, %%rsi; \n\t"//..gets sign bit
		 "add %%rbx, %%rsi; \n\t"// "01b" -- positive number got in array, "10b" -- negative
		 "orq %%rsi, %%rdi; \n\t"// "11b" means the set has mix of positive & negative vals
		 "pand %%xmm2, %%xmm1; \n\t" // gets rid of sign bit
		 "psubq %%xmm5, %%xmm1; \n\t" // takes exponent w/o bias
		 "cmpsd $0, %%xmm1, %%xmm3; \n\t"//compares exponents of current item & previous one (xmm1==xmm3)
		 "pand %%xmm3, %%xmm6; \n\t"// stores the result of comparison
		 "paddq %%xmm1, %%xmm4; \n\t" // calculates the sum of exponents
		 "add %%rbx, %%rdx; \n\t" // increases counter
		 "cmp %%rcx, %%rax; \n\t"
		 "jne ADD0; \n\t"
		 "movlpd %%xmm4, %0; \n\t" // saves sum of exponents
		 "movq %%rdx, %1; \n\t"// saves counter.
		 "movq %%rdi, %2; \n\t"// saves indicator.
		 "movq %%xmm6, %3; \n\t"// saves flag AllExponentsAreEqual
		: "=m"(sum), "=m"(counter), "=m"(flagToFormPivot), "=m"(AllExponentsAreEqual)//output
		:"rax"(adrLRlst0), "rcx"(adrLRfst0)//input
		:"esi", "edi", "ebx"//clobbered
		 );
//		 if(AllExponentsAreEqual)return get_pivotVerI();// mid exponent doesn't work anymore, thereby we count mid significand
		 sum/=counter; // takes the mid exponent
		 sum+=1023; // mid exponent w/ bias
		 sum<<=52;// positive double
		 switch(flagToFormPivot){
			 case 2:
			   counter=1;
			   counter<<=63;
			   sum|=counter; // negative double
			   break;
			 case 3:
			   sum=0; // set will be divided into subsets of negative & positive vals
			 }
	__asm__ (
	     "movlpd %0, %%xmm4; \n\t" //loads pivot
		: "=m"(sum)//output
		://input
		://clobbered
		 );
		 //////////////////////////// compute middle element //////////////////
		 return 1;
}
/*int get_pivotVerII_sd(){//slow denormals
	int64_t sum=-3;
	int64_t counter;
	int64_t num0fdenorm;
	int64_t sum0fdenormExps; // sum of denormal's exponents
	int flagToFormPivot;
	int AllExponentsAreEqual;
	//////////////////////////// compute middle element //////////////////
		__asm__ (
		"pcmpeqw %%xmm6, %%xmm6; \n\t"// is flag (2^64 - 1) to whether all exponents are equal each other in given set
		"pxor %%mm2, %%mm2;\n\t"//sum of denormal's exponents
		"pxor %%mm5, %%mm5;\n\t"// initilize (mm5 is prev. denormal's exponent)
		"pxor %%mm7, %%mm7;\n\t"
		"pxor %%xmm7, %%xmm7;\n\t"
		"movq $ret_norm, %%rbx; \n\t"
		"movq $to_denorm, %%rdx; \n\t"
		"sub %%rbx, %%rdx;\n\t"
		"movq %%rbx, %%mm0;\n\t"//base to call calculator of exponent (for normals)
		"movq %%rdx, %%mm1;\n\t"//offset to call calculator for denormals
		"movq %%rsp, %%xmm7;\n\t"//borrow extra gpr for our needs ;)
		"xorq %%rsp, %%rsp; \n\t"
		//"PSHUFD $0x4E, %%xmm7, %%xmm7; \n\t"// rotates xmm7 to use low 64 bits as mask to prevent comparison of 1st denormal w/ illegal item 
		//"movsd %%xmm6, %%xmm7;\n\t"//sets the mask
		"movq $1074, %%rsi;\n\t"//..
		"movq %%rsi, %%mm3;\n\t"//.. const to calculate denormal's exponent
		"xorq %%rdi, %%rdi; \n\t"// esi is var to configure the indicator[binary flags in edi] whether array has positive/negative vals.
		"xorq %%rdx, %%rdx; \n\t" // clear the counter
		"movq $0x1, %%rbx; \n\t" // set unit to increase counter
		"PSHUFD $0x44, %%xmm6, %%xmm3; \n\t"// xmm3 stores flag to complete 1st run
		// put "1023" const in the low int64
		// the mask to count exponent of denormals
		"PSHUFD $0x44, %%xmm6, %%xmm0; \n\t"
		"psrlq $0xc, %%xmm0 ; \n\t"// == 2^52 - 1
		// the mask to count exponent of denormals
		 "PSHUFD $0x44, %%xmm6, %%xmm5; \n\t"
         "psrlq $53, %%xmm5 ; \n\t"
		 "PSHUFD $0x44, %%xmm5, %%xmm2; \n\t" // set the mask (2^11 - 1) for exponent
		 "psrlq $1, %%xmm5 ; \n\t"
		 // put "1023" const in the bottom int64
		 "xorpd %%xmm4, %%xmm4; \n\t"
		 "jmp fst_run1; \n\t"
		 //ADD:
		 "ADD1: add $0x8, %%rax; \n\t"// pointer to next item
		 //First run:
		 "fst_run1: movq (%%rax), %%xmm1; \n\t" // loads current item
		 "PSHUFD $0x44, %%xmm1, %%xmm6; \n\t"// loads previous item
		 "movdq2q %%xmm1, %%mm4; \n\t" //saves current item for calculation of denormal's exponent, if required
		 "psrlq $0x34, %%xmm1; \n\t" // gets exponent & sign bit as well
		 "movq %%xmm1, %%rsi; \n\t"// gets exponent & sign bit 
		 "pand %%xmm2, %%xmm1; \n\t" // gets rid of sign bit
		 "movdq2q %%xmm1, %%mm7; \n\t"// exponent bits are used as key to switch between calculators of exponent for normal numbers & denormals
		 "pxor %%mm6, %%mm6;\n\t"// set to zero
		 "pcmpeqd %%mm7, %%mm6; \n\t"// zero of exponent bits means current number is denormal
		 "pand %%mm1, %%mm6 ; \n\t"//gets offset to call calculator of (de)normal's exponent  
		 "paddd %%mm0, %%mm6 ; \n\t"// generates flat address to jump into due calculator 
		 "movq %%mm6, %%rsi ; \n\t"// moves address of calculator to general purpose register
		 "call *%%rsi; \n\t"// calls proper calculator of exponent
		 "jmp norm;\n\t"
		 "ret_norm: retq;\n\t"
		 "to_denorm: jmp denorm;\n\t"
		 //Normals:
		 "norm: shrq $0xb, %%rsi; \n\t"//gets sign bit
		 "add %%rbx, %%rsi; \n\t"// "01b" -- positive number got in array, "10b" -- negative
		 "orq %%rsi, %%rdi; \n\t"// "11b" means the set has mix of positive & negative vals
		 "cmpsd $0, %%xmm1, %%xmm3; \n\t"//compares exponents of current item & previous one (xmm1==xmm3)
		 "pand %%xmm3, %%xmm6; \n\t"// stores the result of comparison for normals
		 "paddq %%xmm1, %%xmm4; \n\t" // calculates the sum of exponents
		 "add %%rbx, %%rdx; \n\t" // increases counter
		 "cmp %%rcx, %%rax; \n\t"
		 "jne ADD1; \n\t"
		 "jmp fin;\n\t"
		 //Denormals:
		 "denorm: movdq2q %%xmm0, %%mm6;\n\t"//loads the mask
		 "pand %%mm6, %%mm4;\n\t"//trims to the 52 L.O. bits of double
		 "pxor %%mm7, %%mm7;\n\t"
		 "sub %%rbx, %%rdx;\n\t"// prevents double count of normals
		 //"PSHUFW $0xE4, %%mm4, %%mm7; \n\t"
		 "pxor %%mm6, %%mm6;\n\t"
		 "pcmpeqd %%mm5, %%mm6; \n\t"//checks out whether prev. denormal existed: denormal's exponent cannot be equal to zero
		 "por %%mm6, %%mm7; \n\t"//set flag of first run for denormals
		 "pxor %%mm6, %%mm6;\n\t"
		 "if_delimiter_no_taken: pcmpeqd %%mm4, %%mm6; \n\t"
		 "movq %%mm6, %%rsi;\n\t"
		 "psrlq $1, %%mm4;\n\t"//right shift
		 "xorq %%rbx, %%rsi;\n\t"// if esi==0, res==1; if 2^32 - 1, 2^32 - 2
		 "and %%rbx, %%rsi;\n\t"// if 1 || 2^32 - 2, result == 1 || 0 (ebx == 1)
		 "add %%rsi, %%rsp;\n\t"
		 "pxor %%mm6, %%mm6;\n\t"
		 "cmp %%rbx, %%rsi;\n\t"
		 "jne if_delimiter_no_taken;\n\t"
		 "movq %%rsi, %%mm6;\n\t"
		 "PSHUFW $0xE4, %%mm3, %%mm4;\n\t"// set const of denormal exponent (1074)
		 "psubd %%mm6, %%mm4;\n\t"// denormal's exponent
		 "paddq %%mm4, %%mm2;\n\t"//sum of denormal's exponents
		 "pcmpeqd %%mm4, %%mm5; \n\t"//compares previous & current denormal's exponents
		 "por %%mm7, %%mm5; \n\t"//set flag of first run + result of comparison
		 "movq2dq %%mm5, %%xmm5;\n\t"//set flag for denormal's exponents
		 "PSHUFW $0xE4, %%mm4, %%mm5; \n\t"//set prev. exponent
		 "pand %%xmm5, %%xmm6;\n\t"// nullifies normal exponent to prevent double count
		 "retq;\n\t"
		 "fin: movlpd %%xmm4, %0; \n\t" // saves sum of exponents
		 "movq %%rdx, %1; \n\t"// saves counter.
		 "movq %%rdi, %2; \n\t"// saves indicator whether array consists of positive o/& negative vals.
		 "movq %%xmm6, %3; \n\t"// saves flag AllExponentsAreEqual
		 "movq %%mm2, %4;\n\t"// saves the sum of denormal's exponents
		 "movq %%rsp, %5;\n\t"// saves the num of denormals
		 "movq %%xmm7, %%rsp;\n\t"// restores esp
		: "=m"(sum), "=m"(counter), "=m"(flagToFormPivot), "=m"(AllExponentsAreEqual), "=m"(sum0fdenormExps), "=m"(num0fdenorm)//output
		:"a"(adrLRlst0), "c"(adrLRfst0)//input
		:"esi", "edi", "ebx"//clobbered
		 );
		 if(AllExponentsAreEqual)return get_pivotVerI();// mid exponent doesn't work anymore, thereby we count mid significand
		 sum/=counter; // takes the mid exponent
		 sum+=1023; // mid exponent w/ bias
		 sum<<=52;// positive double
		 switch(flagToFormPivot){
			 case 2:
			   counter=1;
			   counter<<=63;
			   sum|=counter; // negative double
			   break;
			 case 3:
			   sum=0; // set will be divided into subsets of negative & positive vals
			 }
	__asm__ (
	     "movlpd %0, %%xmm4; \n\t" //loads pivot
		: "=m"(sum)//output
		://input
		://clobbered
		 );
		 //////////////////////////// compute middle element //////////////////
		 return 1;
}*/
int simplePVT(){
	__asm__ (
	     "movq (%%r9), %%xmm4; \n\t"
		 "movq $2, %%rax   ; \n\t"
		 "popq %%rbp         ; \n\t"
	     "ret                ; \n\t"
	    :                              //output
		:      //input
		: //clobbered
	);
	
}
int pivot_rnd(){
	__asm__ (
	     "movq %%r8, %%xmm14; \n\t"
		 "movq %%r9, %%xmm15; \n\t"
	    :                              //output
		:      //input
		: //clobbered
	);
	int64_t num0fItems=(adrLR.lst - adrLR.fst)/8;
	if(num0fItems == 0)num0fItems++;
	int64_t ind=rand() % num0fItems;
	 __asm__ (
	     "movq %%xmm14, %%r8; \n\t"
		 "movq %%xmm15, %%r9; \n\t"
	     "addq %%r8, %%rax; \n\t"
		 "movq (%%rax), %%xmm4; \n\t"
		 "movq $2, %%rax; \n\t"
	    :                              //output
		:"a"(ind)      //input
		: //clobbered
	);
	return 0;
}
int get_pivotVerI(void);

void partiallyOrdering(int shiftL, int shiftR){
	//if(adrLRfst0 == adrLRlst0)return;
	__asm__ (
	     "xorq %%rdi, %%rdi; \n\t"
		 "not %%rdi       ; \n\t"
		 "lea (, %%rdx, 0x8), %%rdx; \n\t"
		 "sub %%rdx, %%rcx; \n\t"
		 "lea (%%rax, %%rbx, 0x8), %%rax; \n\t"
		 "movq (%%rcx), %%xmm2; \n\t"
		 "movq (%%rax), %%xmm1; \n\t"
		 "jmp fst_go          ; \n\t"
         "go:                 ; \n\t"
		 "add $0x8, %%rax     ; \n\t"
		 "sub $0x8, %%rcx     ; \n\t"
		 "fst_go:             ; \n\t"
		 "PSHUFD $0x44, %%xmm1, %%xmm6; \n\t"
		 "cmpsd $0x1, %%xmm2, %%xmm6; \n\t"
		 "movq %%xmm6, %%rsi; \n\t"
		 "cmp %%rsi, %%rdi; \n\t"
		 "je swp8          ; \n\t"
		 //"jmp no_swp      ; \n\t"
		 "swp8:            ; \n\t"
		 "movq %[swp], %%rsi; \n\t"
		 "call *%%rsi; \n\t"
		 "cmp %%rcx, %%rax; \n\t"
		 "jb go; \n\t"
		 
		 :[swp]"=m"(GV0.swp)//output
		:"a"(adrLRlst0), "c"(adrLRfst0), "b"(shiftL), "d"(shiftR)//input
		://clobbered
		 );
}
int // __attribute__((aligned(4)))
 get_pivotVerI(){
	//////////////////////////// compute middle element //////////////////
	/* initialize random seed: */
 // srand (time(NULL));
   
		__asm__ (
		// put "1" const in the top double
	//	"movq %%r15, %%xmm15;\n\t"
		"mov %[fst], %%rax;\n\t"
		"mov %[lst], %%rcx;\n\t"
		"movq %[align], %%r10;\n\t"
		//"mov %[rnd], %%r15;\n\t"
		"mov (%%rax), %%rsi;\n\t"
		"mov 0x4(%%rax), %%rdi;\n\t"
		//"xorq %[rnd], %%rdi;\n\t"
		//"not %%r10;\n\t"
		"xorq %%rdi, %%rsi;\n\t"
		"movq %%rcx, %%rdi;\n\t"
		//"movq %%rax, %%r10;\n\t"
		"sub %%rax, %%rdi;\n\t"
		//"sub %%r10, %%rcx;\n\t"
		"call unity      ;\n\t"
		//"movq %%rcx, %%r10;\n\t"
		"and %%rdi, %%rsi;\n\t"
		"and %%r10, %%rsi;\n\t"
		//"shrq $3, %%rsi   ;\n\t"
		//"shl $3, %%rsi   ;\n\t"
		"add %%rsi, %%rax;\n\t"
		"movq $128, %%rsi;\n\t"
		"movq %%rcx, %%rdi;\n\t"
		"sub %%rax, %%rdi;\n\t"
		"call unity_upper;\n\t"
		"and %%rdi, %%rsi;\n\t"
		"movq %%rax, %%rcx;\n\t"
		"add %%rsi, %%rcx;\n\t"
	/*	 "pcmpeqw %%xmm5, %%xmm5; \n\t"
         "pslldq $8, %%xmm5 ; \n\t"
		 "psrlq $63, %%xmm5 ; \n\t"*/
		 //"movq %%rsi, %%r10; \n\t"
		 "shrq   $3,  %%rsi; \n\t"
		 "addq   $1,  %%rsi; \n\t"
	         
		
		 //"movq %%rax, %%r11; \n\t"
		 // put/ "1" const in the top double
		 "xorpd %%xmm4, %%xmm4; \n\t"
		 "movq (%%rax), %%xmm1; \n\t"
		//"prefetcht2 (%%rax); \n\t"
		 "PSHUFD $0x44, %%xmm1, %%xmm3; \n\t"
		 "PSHUFD $0x44, %%xmm1, %%xmm15; \n\t"
		 "movq %%rax, %%r10; \n\t"
		
		 // "movq (%%rcx), %%xmm15; \n\t"
		 "jmp fst_run         ; \n\t"
         "ADD: add $0x8, %%rax; \n\t"
		// "movq (%%rax), %%xmm1; \n\t"
		 //"PSHUFD $0x44, %%xmm1, %%xmm6; \n\t"
	         "add $0x8, %%r10; \n\t"
	          //"add $0x8, %%r11; \n\t"
		 "maxsd (%%rax), %%xmm15; \n\t"
		 //"PSHUFD $0x4E, %%xmm3, %%xmm3; \n\t"
		"minsd (%%r10), %%xmm3; \n\t"
		 //"PSHUFD $0x4E, %%xmm3, %%xmm3; \n\t"
		 "fst_run:            ; \n\t"
		// "prefetcht1 0x8(%%rax); \n\t"
		// "divsd %%xmm14, %%xmm1; \n\t" // copy bottom of xmm4 (previous state) to bottom & top of xmm6
		 "addsd (%%rax), %%xmm4; \n\t"
		// "addsd %%xmm1, %%xmm4; \n\t"
		 //"addq %%r11, %%r10; \n\t"
		 "cmp %%rcx, %%rax; \n\t"
		 "jb ADD; \n\t"
		 "inftst:               ;\n\t"
		  
		 "PSHUFD $0xEE, %%xmm3, %%xmm0; \n\t"//copies the least item
		 //"PSHUFD $0x44, %%xmm15, %%xmm7; \n\t"//copies the most item
		 "addsd %%xmm15, %%xmm3; \n\t"
		 "divsd %%xmm13, %%xmm3; \n\t"//gets mean value: (the-least+the-most)/2
		 //"PSHUFD $0xEE, %%xmm4, %%xmm1; \n\t" // put counter from the top xmm4 to both sides of xmm1
		
		 "cvt0:               ;\n\t"
		 "movq %%rsi, %%xmm1; \n\t"//put counter to xmm1
	         "CVTDQ2PD %%xmm1, %%xmm1; \n\t"//converts counter (int) to double
		 "divsd %%xmm1, %%xmm4; \n\t"// [low xmm4]/counter == middle element of set to sort.
		 "PSHUFD $0x44, %%xmm4, %%xmm2; \n\t"//stores pivot to check pivot(xmm4) bounds: the-least-val-in-array < pivot < the-most-val
		 "cmpsd $1, %%xmm4, %%xmm0; \n\t"//checks out pivot > the-least-item (if so -- xmm0 == 0xFF..F, otherwise it gets 0x0)
		 "cmpsd $1, %%xmm15, %%xmm2; \n\t"//verify pivot < the-most-item (if so -- xmm2 == 0xFF..F, otherwise it gets 0x0)
		 "pand %%xmm0, %%xmm2; \n\t"// now, xmm2 is flag whether bounds are normal or not
		 "pand %%xmm2, %%xmm4; \n\t"//from here, we generate pivot within proper bounds
		 "pandn %%xmm3, %%xmm2; \n\t"
		 "paddq %%xmm2, %%xmm4; \n\t"//*/
	         /* "PSHUFD $0x44, %%xmm4, %%xmm2; \n\t"//stores pivot to check pivot(xmm4) bounds: the-least-val-in-array < pivot < the-most-val
		 "cmpsd $1, %%xmm4, %%xmm0; \n\t"//checks out pivot > the-least-item (if so -- xmm0 == 0xFF..F, otherwise it gets 0x0)
		 "cmpsd $1, %%xmm15, %%xmm2; \n\t"//verify pivot < the-most-item (if so -- xmm2 == 0xFF..F, otherwise it gets 0x0)
		 "pand %%xmm0, %%xmm2; \n\t"// now, xmm2 is flag whether bounds are normal or not
		 "movq %%xmm2, %%rax          ; \n\t"
		 //"andq %%rdx, %%rax           ; \n\t"//gets CF (carry) flag. If CF==1 -- xmm2 > xmm1
	          //"cmp $0, %%rax; \n\t"
		 "jz NOchange_pvt             ; \n\t"
		 "PSHUFD $0x44, %%xmm3, %%xmm4; \n\t"
		 "NOchange_pvt:               ; \n\t"//*/
		 /*"cmp $80, %%r10; \n\t"
		 "jg t0          ; \n\t"
		 "movq $2, %%rax ; \n\t"*/
		 "t0:            ;\n\t"
		 "movq $0, %%rax ;\n\t"
		 //"movq %%xmm15, %%r15;\n\t"
		 "leaveq             ;\n\t"
         "rtn2: retq          ;\n\t"	
 ////////////// leftmost bit (of edi) becomes "0", others turn to "1" state/////////////
         "fst_unity:          ;\n\t"
		 //"pushq %%rbp      ;\n\t"
		 "movq %%rdi, %%rbx;\n\t"
		 "notq %%rbx       ;\n\t"	
         "negq %%rdi       ;\n\t"
         "orq  %%rbx, %%rdi;\n\t"
         "notq %%rdi       ;\n\t" 
		 "subq   $1,  %%rdi;\n\t"
		 "retq             ;\n\t"
		 "unity:          ;\n\t"
		 //"pushq %%rbp      ;\n\t"
		 "movq %%rdi, %%rbx;\n\t"
		 "shrq $1, %%rbx   ;\n\t"
		 "orq %%rbx, %%rdi;\n\t"
		 "orq %%rdi, %%rbx;\n\t"
		 "shrq $2, %%rbx   ;\n\t"
		 "orq %%rbx, %%rdi;\n\t"
		 "orq %%rdi, %%rbx;\n\t"
		 "shrq $4, %%rbx   ;\n\t"
		 "orq %%rbx, %%rdi;\n\t"
		 "orq %%rdi, %%rbx;\n\t"
		 "shrq $8, %%rbx   ;\n\t"
		 "orq %%rbx, %%rdi;\n\t"
		 /*"orq %%rdi, %%rbx;\n\t"
		 "shrq $16, %%rbx   ;\n\t"
		 "orq %%rbx, %%rdi;\n\t"//*/
		 "shrq $1, %%rdi   ;\n\t"
		 //"popq %%rbp       ;\n\t"
		 "retq             ;\n\t"
		 "unity_upper:          ;\n\t"
		 //"pushq %%rbp      ;\n\t"
		 "movq %%rdi, %%rbx;\n\t"
		 "shrq $1, %%rbx   ;\n\t"
		 "orq %%rbx, %%rdi;\n\t"
		 "orq %%rdi, %%rbx;\n\t"
		 "shrq $2, %%rbx   ;\n\t"
		 "orq %%rbx, %%rdi;\n\t"
		 //"orq %%rdi, %%rbx;\n\t"
		 //"shrq $4, %%rbx   ;\n\t"
		 "shrq $1, %%rdi   ;\n\t"
		 //"popq %%rbp       ;\n\t"
		 "retq             ;\n\t"
 ////////////// leftmost bit (of edi) becomes "0", others turn to "1" state/////////////
		:[fst]"=r"(adrLRlst0), [lst]"=r"(adrLRfst0), [align]"=m"(consts.fffffffffffffff8), [rnd]"=m"(consts.rnd) //output
		://"rax"(adrLRlst0), "rcx"(adrLRfst0)//input
		://clobbered
		 );

		 //////////////////////////// compute middle element //////////////////
}
int get_pvt3(){
	//////////////////////////// compute middle element //////////////////
	/* initialize random seed: */
 // srand (time(NULL));
// int64_t rnd = rand() % (1024LL*1024LL*1024LL) + 1;
		__asm__ (
		// put "1" const in the top double
	//	"movq %%r15, %%xmm15;\n\t"
		"mov %[fst], %%rax;\n\t"
		"mov %[lst], %%rcx;\n\t"
		//"mov %[rnd], %%r15;\n\t"
		"mov (%%rax), %%rsi;\n\t"
		"mov 0x4(%%rax), %%rdi;\n\t"
		//"xorq %%r15, %%rdi;\n\t"
		"xorq %%rdi, %%rsi;\n\t"
		"movq %%rcx, %%rdi;\n\t"
		"sub %%rax, %%rdi;\n\t"
		"call unity1      ;\n\t"
		"and %%rdi, %%rsi;\n\t"
		"shrq $3, %%rsi   ;\n\t"
		"shl $3, %%rsi   ;\n\t"
		"add %%rsi, %%rax;\n\t"
		 "movq (%%rax), %%xmm4; \n\t"
		"t1: movq $0, %%rax;\n\t"
		 //"movq %%xmm15, %%r15;\n\t"
	    "leaveq             ;\n\t"
        "rtn3: retq          ;\n\t"	
 ////////////// leftmost bit (of edi) becomes "0", others turn to "1" state/////////////	 
		 "unity1:          ;\n\t"
		 //"pushq %%rbp      ;\n\t"
		 "movq %%rdi, %%rbx;\n\t"
		 "shrq $1, %%rbx   ;\n\t"
		 "orq %%rbx, %%rdi;\n\t"
		 "movq %%rdi, %%rbx;\n\t"
		 "shrq $2, %%rbx   ;\n\t"
		 "orq %%rbx, %%rdi;\n\t"
		 "movq %%rdi, %%rbx;\n\t"
		 "shrq $4, %%rbx   ;\n\t"
		 "orq %%rbx, %%rdi;\n\t"
		 "movq %%rdi, %%rbx;\n\t"
		 "shrq $8, %%rbx   ;\n\t"
		 "orq %%rbx, %%rdi;\n\t"
		 "movq %%rdi, %%rbx;\n\t"
		 "shrq $16, %%rbx   ;\n\t"
		 "orq %%rbx, %%rdi;\n\t"
		 "shrq $1, %%rdi   ;\n\t"
		 //"popq %%rbp       ;\n\t"
		 "retq             ;\n\t"
 ////////////// leftmost bit (of edi) becomes "0", others turn to "1" state/////////////
		:[fst]"=r"(adrLRlst0), [lst]"=r"(adrLRfst0) //, [rnd]"=m"(rnd) //output
		://"rax"(adrLRlst0), "rcx"(adrLRfst0)//input
		://clobbered
		 );

		 //////////////////////////// compute middle element //////////////////
}
int64_t register frd_patch asm("r12");
int  __attribute__((aligned(4)))
 get_pivotVerII(){
	int64_t sum=0;// sum of normal exp's
	int64_t counter=0;// number of normal exponents
	int64_t num0fdenorm=0;
	int64_t sum0fdenormExps=0; // sum of denormal's exponents
	int flagToFormPivot;// bits in this flag:
	//1st -- array has positive vals
	//2nd -- negatives
	//3rd -- normals
	//4th -- denormals
	double mean;
	double maxDenorm;
	double maxNorm;
	double minDenorm;
	double minNorm;
	//int fst_patch=0x2;
	int fin_patch;
	int adr02ins=0;
	int fst_run_of_dn;
	//////////////////////////// compute middle element //////////////////
		__asm__ (
		"movq %%r9, %%xmm15;\n\t" // saves global variables (adrLR[l/f]st0)
		"movq %%r8, %%xmm14;\n\t"
		"pxor %%mm2, %%mm2;\n\t"//sum of denormal's exponents
		"pxor %%mm0, %%mm0;\n\t"// free var
		"pxor %%mm7, %%mm7;\n\t"
		"rng:             ;\n\t"
		"movq %%rcx, %%rdi;\n\t"
		"sub %%rax, %%rdi;\n\t"
		"shrq $9, %%rdi;\n\t"
		"movq %%rdi, %%rcx;\n\t"
		"add %%rax, %%rcx;\n\t"
		 "movq $32, %%r11;\n\t"
		/*///////////////////////////
		"mov (%%rax), %%rsi;\n\t"
		"mov 0x4(%%rax), %%rdi;\n\t"
		"xorq %%rdi, %%rsi;\n\t"
		"movq %%rcx, %%rdi;\n\t"
		"sub %%rax, %%rdi;\n\t"
		"call unity0      ;\n\t"
		"and %%rdi, %%rsi;\n\t"
		"shrq $3, %%rsi   ;\n\t"
		"shl $3, %%rsi   ;\n\t"
		"add %%rsi, %%rax;\n\t"
		"movq $10, %%rsi;\n\t"
		"movq %%rcx, %%rdi;\n\t"
		"sub %%rax, %%rdi;\n\t"
		"call unity0      ;\n\t"
		"and %%rdi, %%rsi;\n\t"
		"movq %%rax, %%rcx;\n\t"
		"add %%rsi, %%rcx;\n\t"
		/////////////////////////////*/
		"movq $ret_norm1, %%r13; \n\t"//base to call calculator of exponent (for normals)
		"movq $to_denorm1, %%r14; \n\t"//offset to call calculator for denormals
		"sub %%r13, %%r14;\n\t"
		"xorq %%rdi, %%rdi; \n\t"// esi is var to configure the indicator[binary flags in edi] whether array has positive/negative (de)normal vals.
		"xorq %%rdx, %%rdx; \n\t" // counter for normals
		"movq $0x1, %%rbx; \n\t" // set unit to increase counter
		"movq $frn, %%r8; \n\t" // set pointer to jump normal's handler
		"xor %%r9, %%r9;\n\t"//denormal counter
		// put "1023" const in the low int64
		"pcmpeqw %%xmm2, %%xmm2; \n\t"
		// the mask to count exponent of denormals
		"movq %[mask4MOunity], %%xmm0; \n\t"
		//"psrlq $0xc, %%xmm0 ; \n\t"// == 2^52 - 1
		// the mask to count exponent of denormals
         "psrlq $53, %%xmm2 ; \n\t" // set the mask (2^11 - 1) for exponent
		 "xorpd %%xmm4, %%xmm4; \n\t"// nullifies the sum of normal exp's
		 "pxor %%xmm3, %%xmm3; \n\t"// default state for the least/largest normal
		 "pxor %%xmm5, %%xmm5; \n\t"// default state for the least/largest denormal
		 "jmp fst_run2; \n\t"
		 "ADD2: add $0x8, %%rax; \n\t"// pointer to next item
		 "fst_run2: ;\n\t"
		 "prefetcht1 0x8(%%rax); \n\t"
		 "movq (%%rax), %%xmm1; \n\t" // loads current item
		 "movdq2q %%xmm1, %%mm4; \n\t" //saves current item for calculation of denormal's exponent, if required
		 "PSHUFD $0x44, %%xmm1, %%xmm6; \n\t"//saves current item to estimate the least & largest (de)normals 
		 "psrlq $0x34, %%xmm1; \n\t" // gets exponent & sign bit as well
		 "movq %%xmm1, %%rsi; \n\t"// gets exponent & sign bit 
		 "pand %%xmm2, %%xmm1; \n\t" // gets rid of sign bit
		 "movdq2q %%xmm1, %%mm7; \n\t"// exponent bits are used as key to switch between calculators of exponent for normal numbers & denormals
		 "pxor %%mm6, %%mm6;\n\t"// set to zero
		 "pcmpeqd %%mm7, %%mm6; \n\t"// zero of exponent bits means current number is denormal
		 "movq %%mm6, %%r15 ; \n\t"// moves the mask to general purpose register
		 "and %%r14, %%r15 ; \n\t"//gets offset to call calculator of (de)normal's exponent  
		 "add %%r13, %%r15 ; \n\t"// generates flat address to jump into due calculator 
		 "shrq $0xb, %%rsi; \n\t"//gets sign bit
		 "add %%rbx, %%rsi; \n\t"// "01b" -- positive number got in array, "10b" -- negative
		 "orq %%rsi, %%rdi; \n\t"// "11b" means the set has mix of positive & negative vals
		 "ebp:         ;\n\t"
		 "jmp *%%r15; \n\t"// calls proper calculator of exponent
		 "ret_norm1: jmp *%%r8;\n\t"
		 "to_denorm1: jmp denorm1;\n\t"
		 "norm1: maxsd %%xmm6, %%xmm3; \n\t"//xmm3 = max(xmm1, xmm3)
		 "PSHUFD $0x4E, %%xmm3, %%xmm3;\n\t"//rotates top to bottom & vice versa
		 "minsd %%xmm6, %%xmm3;\n\t"//xmm3=min(xmm3, xmm6), xmm3 is the least & largest normal
		 "PSHUFD $0x4E, %%xmm3, %%xmm3;\n\t"
		 "paddq %%xmm1, %%xmm4; \n\t" // calculates the sum of exponents
		 "add %%rbx, %%rdx; \n\t" // increases counter
		 "loop: cmp %%rcx, %%rax; \n\t"
		 "      jb ADD2; \n\t"
		 "jmp fin1;\n\t"
		 //DENORMALS:
		 //////// initialize 
		 "denorm1:                                      ;\n\t"//loads the mask
		 "pand %[mask4mantissa], %%mm4;\n\t"//trims current denormal to the 52 L.O. bits
		 "movdq2q %%xmm0, %%mm6;\n\t"// sets the mask to isolate M. O. bits (FF FF FF FF 00 00 00 00)
		 /////////////////// sets basic shift 2^5
		 "movq %%r11, %%mm7;\n\t"// sets to 0x20
		 /////////////////// sets basic shift 2^5
		  ////////////////// shift's correction
		  "PSHUFW $0xE4, %%mm7, %%mm3; \n\t"// copies basic shift
		  "psrlq $1, %%mm3;\n\t"//sets initial absolute value of shift's correction (0x10)
		  ////////////////// shift's correction
		// "pxor %%mm0, %%mm0;\n\t"// sets zero
		 //////// initialize
		 // 1st step (offset 0x10)
		 "PSHUFW $0xE4, %%mm4, %%mm1; \n\t"// copies current denormal
		 "pand %%mm6, %%mm1;\n\t"// isolates M. O. bits, 1's
		 //sets the mask for shift's correction: if mm0==mm1 -- mm1=0xFF(8), otherwise mm1=0 (mm0 == 0)
		 "pcmpeqd %%mm0, %%mm1; \n\t"
		 "pshufw $0x4E, %%mm1, %%mm5; \n\t"
		 "pand %%mm5, %%mm1; \n\t"
		 //sets the mask for shift's correction: if mm0==mm1 -- mm1=0xFF(8), otherwise mm1=0 (mm0 == 0)
		 "pand %%mm3, %%mm1; \n\t"//gets shift's correction towards rightmost bits
		 "psrlq %%mm1, %%mm6;\n\t"// shifts the mask to right
		 "psubq %%mm1, %%mm7;\n\t"//corrects basic shift (shift's correction is either 0 o 2^n, n<5)
		 "pxor %%mm3, %%mm1; \n\t"//gets shift's correction towards leftmost bits
		 "psllq %%mm1, %%mm6;\n\t"// shifts the mask to left
		 "paddq %%mm1, %%mm7;\n\t"//corrects basic shift (shift's correction is either 0 o 2^n, n<5)
		 "psrlq $1, %%mm3;\n\t"// adjusts shift's correction to next step
		 //2nd step (offset 0x8)
		 "PSHUFW $0xE4, %%mm4, %%mm1; \n\t"// copies current denormal
		 "pand %%mm6, %%mm1;\n\t"// isolates M. O. bits
		 //sets the mask for shift's correction: if mm0==mm1 -- mm1=0xFF(8), otherwise mm1=0 (mm0 == 0)
		 "pcmpeqd %%mm0, %%mm1; \n\t"
		 "pshufw $0x4E, %%mm1, %%mm5; \n\t"
		 "pand %%mm5, %%mm1; \n\t"
		 //sets the mask for shift's correction: if mm0==mm1 -- mm1=0xFF(8), otherwise mm1=0 (mm0 == 0)
		 "pand %%mm3, %%mm1; \n\t"//gets shift's correction towards rightmost bits
		 "psrlq %%mm1, %%mm6;\n\t"// shifts the mask to right
		 "psubq %%mm1, %%mm7;\n\t"//corrects basic shift (shift's correction is either 0 o 2^n, n<5)
		 "pxor %%mm3, %%mm1; \n\t"//gets shift's correction towards leftmost bits
		 "psllq %%mm1, %%mm6;\n\t"// shifts the mask to left
		 "paddq %%mm1, %%mm7;\n\t"//corrects basic shift (shift's correction is either 0 o 2^n, n<5)
		 "psrlq $1, %%mm3;\n\t"// adjusts shift's correction to next step
		 //3rd step -- offset 0x4
		 "PSHUFW $0xE4, %%mm4, %%mm1; \n\t"// copies current denormal
		 "pand %%mm6, %%mm1;\n\t"// isolates M. O. bits
		 //sets the mask for shift's correction: if mm0==mm1 -- mm1=0xFF(8), otherwise mm1=0 (mm0 == 0)
		 "pcmpeqd %%mm0, %%mm1; \n\t"
		 "pshufw $0x4E, %%mm1, %%mm5; \n\t"
		 "pand %%mm5, %%mm1; \n\t"
		 //sets the mask for shift's correction: if mm0==mm1 -- mm1=0xFF(8), otherwise mm1=0 (mm0 == 0)
		 "pand %%mm3, %%mm1; \n\t"//gets shift's correction towards rightmost bits
		 "psrlq %%mm1, %%mm6;\n\t"// shifts the mask to right
		 "psubq %%mm1, %%mm7;\n\t"//corrects basic shift (shift's correction is either 0 o 2^n, n<5)
		 "pxor %%mm3, %%mm1; \n\t"//gets shift's correction towards leftmost bits
		 "psllq %%mm1, %%mm6;\n\t"// shifts the mask to left
		 "paddq %%mm1, %%mm7;\n\t"//corrects basic shift (shift's correction is either 0 o 2^n, n<5)
		 "psrlq $1, %%mm3;\n\t"// adjusts shift's correction to next step
		 //4th -- offset 0x2
		 "PSHUFW $0xE4, %%mm4, %%mm1; \n\t"// copies current denormal
		 "pand %%mm6, %%mm1;\n\t"// isolates M. O. bits
		 //sets the mask for shift's correction: if mm0==mm1 -- mm1=0xFF(8), otherwise mm1=0 (mm0 == 0)
		 "pcmpeqd %%mm0, %%mm1; \n\t"
		 "pshufw $0x4E, %%mm1, %%mm5; \n\t"
		 "pand %%mm5, %%mm1; \n\t"
		 //sets the mask for shift's correction: if mm0==mm1 -- mm1=0xFF(8), otherwise mm1=0 (mm0 == 0)
		 "pand %%mm3, %%mm1; \n\t"//gets shift's correction towards rightmost bits
		 "psrlq %%mm1, %%mm6;\n\t"// shifts the mask to right
		 "psubq %%mm1, %%mm7;\n\t"//corrects basic shift (shift's correction is either 0 o 2^n, n<5)
		 "pxor %%mm3, %%mm1; \n\t"//gets shift's correction towards leftmost bits
		 "psllq %%mm1, %%mm6;\n\t"// shifts the mask to left
		 "paddq %%mm1, %%mm7;\n\t"//corrects basic shift (shift's correction is either 0 o 2^n, n<5)
		 "psrlq $1, %%mm3;\n\t"// adjusts shift's correction to next step
		 //5th -- offset 0x1
		 "PSHUFW $0xE4, %%mm4, %%mm1; \n\t"// copies current denormal
		 "pand %%mm6, %%mm1;\n\t"// isolates M. O. bits
		 //sets the mask for shift's correction: if mm0==mm1 -- mm1=0xFF(8), otherwise mm1=0 (mm0 == 0)
		 "pcmpeqd %%mm0, %%mm1; \n\t"
		 "pshufw $0x4E, %%mm1, %%mm5; \n\t"
		 "pand %%mm5, %%mm1; \n\t"
		 //sets the mask for shift's correction: if mm0==mm1 -- mm1=0xFF(8), otherwise mm1=0 (mm0 == 0)
		 "pand %%mm3, %%mm1; \n\t"//gets shift's correction towards rightmost bits
		 "psrlq %%mm1, %%mm6;\n\t"// shifts the mask to right
		 "psubq %%mm1, %%mm7;\n\t"//corrects basic shift (shift's correction is either 0 o 2^n, n<5)
		 "pxor %%mm3, %%mm1; \n\t"//gets shift's correction towards leftmost bits
		 "psllq %%mm1, %%mm6;\n\t"// shifts the mask to left
		 "paddq %%mm1, %%mm7;\n\t"//corrects basic shift (shift's correction is either 0 o 2^n, n<5)
		 //denormal's exponent is calculated at this step
		 "paddq %%mm7, %%mm2;\n\t"//sum of exponents
		 "frd:    ;\n\t"
		 "      jmp frd0;\n\t"//first run for denormals. After first getting in, it changes jump to "movq2dq %%mm7, %%xmm5;\n\t"
		 "      nop;\n\t"//nop padding to insert "movq2dq %%mm7, %%xmm5;\n\t" from "frd" label
         "      nop;\n\t"
		//"maxsd %%xmm6, %%xmm5;\n\t"//estimates the least & largest denormal
		 "PSHUFD $0x4E, %%xmm5, %%xmm5;\n\t"
		 "minsd %%xmm6, %%xmm5;\n\t"//
		 "PSHUFD $0x4E, %%xmm5, %%xmm5;\n\t"
		 "addq %%rbx, %%r9;\n\t"//updates denormal counter
		 "jmp loop;\n\t"
		 //FRN -- 1st run for normals
		 // first run must not compare previous & current exponent, so it goes to "ADD2" directly. however, other runs have to go in "norm1", thereby we fix //////////  jmp address at "ret_norm1" from "frn" to "norm1" 
		 "frn:   ;\n\t"
		 "movq %%rbx, %%r15;\n\t"// esi==1
		 "shl $2, %%r15;\n\t"//esi ==2^2
		 "orq %%r15, %%rdi;\n\t"//now, it signals normals got in array
		 "PSHUFD $0x44, %%xmm6, %%xmm3;\n\t"//xmm3 is least/largest normal 
		 "movq $norm1, %%r8;\n\t"
		 "jmp norm1;\n\t"
		 //FRD: search an error right up from here [err]
		 "frd0: ;\n\t"
		 "PSHUFD $0x44, %%xmm6, %%xmm5;\n\t"//xmm5 is least/largest denormal 
		 "movq $frd, %%r15;\n\t"//gets address of jmp to frd0
		 "movq (%%r15), %[frd_patch];\n\t"//saves the patch of first run of denormals (%r12)
		 "movq $patch, %%r10;\n\t"//gets address of patch("maxsd %%xmm6, %%xmm5") to perform other loops then 
		 "movl (%%r10), %%r10d;\n\t"//loads patch
    	 "movl  %%r10d, (%%r15);\n\t"//rewrites "nop; nop; jmp frd0" w/ "maxsd %%xmm6, %%xmm5"
		 "movq %%rbx, %%rsi;\n\t"// esi==1
		 "shl $3, %%rsi;\n\t"//esi ==2^3
		 "orq %%rsi, %%rdi;\n\t"//now, it signals denormals got in array*/ 
		 "addq %%rbx, %%r9;\n\t"//updates denormal counter
		 "l0: jmp loop;\n\t"
		 "patch:      ;\n\t"
		 "maxsd %%xmm6, %%xmm5; \n\t"
		 "PSHUFD $0x4E, %%xmm5, %%xmm5;\n\t"
		 //FIN:
		 "fin1: ;\n\t"
		 //if no denormals exist, xmm5 = xmm3 -- if no normals exist, xmm3 = xmm5  
		 "pxor %%xmm1, %%xmm1; \n\t"
		 "cmppd $0, %%xmm3, %%xmm1; \n\t"
		 "pand %%xmm5, %%xmm1; \n\t"
		 "paddq %%xmm1, %%xmm3; \n\t"
		 
		 "pxor %%xmm1, %%xmm1; \n\t"
		 "cmppd $0, %%xmm5, %%xmm1; \n\t"
		 "pand %%xmm3, %%xmm1; \n\t"
		 "paddq %%xmm1, %%xmm5; \n\t"
		 //if no denormals exist, xmm5 = xmm3 -- if no normals exist, xmm3 = xmm5  
		 "movq %%rdi, %%rsi;\n\t"
		 "shrq $3, %%rsi;\n\t"//takes flag of denormals
		 "cmp $1, %%rsi;\n\t"
		 "je restore_code_4_denormals;\n\t"
		 "jmp no_denormals;\n\t"
		 "restore_code_4_denormals:   ;\n\t"
		 "movq $frd, %%rsi;\n\t"//gets address of jmp to frd0
		 "movq %[frd_patch], (%%rsi);\n\t"//restores "nop; nop; jmp frd0"
		 "no_denormals:               ;\n\t"
		 "movq %%r9, %[num0fdenorm];\n\t"// saves the num of denormals
		 "movq %%xmm4, %[sum]; \n\t" // saves sum of exponents
		 "movq %%rdx, %[counter]; \n\t"// saves counter.
		 "movq %%rdi, %[flagToFormPivot]; \n\t"// saves indicator whether array consists of positive o/& negative vals.
		 "maxsd %%xmm5, %%xmm3; \n\t"//sets upper bound
         "movq %%xmm5, %[maxDenorm]; \n\t"// saves max denormal exponent
		 "movq %%xmm3, %[maxNorm]; \n\t"// saves max normal exponent
		 "PSHUFD $0x4E, %%xmm5, %%xmm5; \n\t"
		 "PSHUFD $0x4E, %%xmm3, %%xmm3; \n\t"
		 "minsd %%xmm5, %%xmm3; \n\t"//sets low bound
		 "movlpd %%xmm5, %[minDenorm]; \n\t"// saves min denormal exponent
		 "movlpd %%xmm3, %[minNorm]; \n\t"// saves min normal exponent
		 "movq %%mm2, %[sum0fdenormExps];\n\t"// saves the sum of denormal's exponents*/
		  "jmp global_vars          ;\n\t"
		  ////////////// leftmost bit (of edi) becomes "0", others turn to "1" state/////////////	 
		 "unity0:          ;\n\t"
		 "movq %%rdi, %%rbx;\n\t"
		 "shrq $1, %%rbx   ;\n\t"
		 "orq %%rbx, %%rdi;\n\t"
		 "movq %%rdi, %%rbx;\n\t"
		 "shrq $2, %%rbx   ;\n\t"
		 "orq %%rbx, %%rdi;\n\t"
		 "movq %%rdi, %%rbx;\n\t"
		 "shrq $4, %%rbx   ;\n\t"
		 "orq %%rbx, %%rdi;\n\t"
		 "movq %%rdi, %%rbx;\n\t"
		 "shrq $8, %%rbx   ;\n\t"
		 "orq %%rbx, %%rdi;\n\t"
		/* "movq %%rdi, %%rbx;\n\t"
		 "shrq $16, %%rbx   ;\n\t"
		 "orq %%rbx, %%rdi;\n\t"*/
		 "shrq $1, %%rdi   ;\n\t"
		 "retq             ;\n\t"
 ////////////// leftmost bit (of edi) becomes "0", others turn to "1" state/////////////
		 "global_vars:; \n\t"//clears mmx registers to use fpu further
		 "movq %%xmm15, %%r9;\n\t" // restores global variables (adrLR[l/f]st0)
		 "movq %%xmm14, %%r8;\n\t"
		:[sum]"=m"(sum), [counter]"=m"(counter), [flagToFormPivot]"=m"(flagToFormPivot), [maxDenorm]"=m"(maxDenorm), [sum0fdenormExps]"=m"(sum0fdenormExps),\
		[num0fdenorm]"=m"(num0fdenorm), [maxNorm]"=m"(maxNorm), [minDenorm]"=m"(minDenorm), [minNorm]"=m"(minNorm), [adr02ins]"=m"(adr02ins), \
        [fin_patch]"=m"(fin_patch), [esp]"=m"(adrLR.ESP), [frd_patch]"=r"(frd_patch), [mask4MOunity]"=m"(consts.ffffffff00000000), [mask4mantissa]"=m"(consts.h000fffffffffffff)        //output
		:"a"(adrLRlst0), "c"(adrLRfst0)//input
		:"rsi", "rdi", "rbx"            //clobbered
		 );
		 int kind0fVals=flagToFormPivot>>2; // the kind of vals have gotten at given array: 3 == norms & denorms as well, 1 == norms, 2 == denorms.
		 flagToFormPivot&=3;//clears 3rd & 4th bits [flags of (de)normal's presence in given array]
		 cpp:
		 if (sum > 0){
			 sum/=counter; // takes the mid normal exponent
			 sum-=1023; // mid exponent w/o bias
			 sum*=counter;//the pure sum of normal exps
		 }
		 if (num0fdenorm > 0){
		     sum0fdenormExps/=num0fdenorm;
		     sum0fdenormExps-=1075;// the mid denormal exponent
			 sum0fdenormExps*=num0fdenorm;// the pure sum of denormal exps
		 }
         counter+=num0fdenorm;// total number of exps
		 sum+=sum0fdenormExps;//overall sum of exps (denormals & normals)
		 sum/=counter;// the common mid exp
		 if(sum < -1022){//positive denormal
			 sum+=1075;
			 sum=1LL<<sum;
			 if(sum<0)
				 sum*=-1;
			 sum--;
		 }else {
			  sum+=1023;//adds bias
              sum<<=52;// positive normal
		 }
		 switch(flagToFormPivot){
			 case 2:
			   counter=1LL;
			   counter<<=63;
			   sum|=counter; // negative double
			   break;
			 case 3:
			   sum=0; // set will be divided into subsets of negative & positive vals
			 }
			// mean=(double)sum;
		__asm__ (
		"cvt:               ;\n\t"
	     "movlpd %0, %%xmm4; \n\t"//loads pivot
		 //"pshufd $0x44, %%xmm4, %%xmm0; \n\t"
		 //"movlpd %[pvtCor], %%xmm2; \n\t"
		 //"CVTDQ2PD %%xmm2, %%xmm2; \n\t"
		 //"divsd %%xmm2, %%xmm0; \n\t"
		// "addsd %%xmm0, %%xmm4; \n\t"
		 "movlpd %%xmm4, %[mean]; \n\t"//saves pivot into var to check bounds (pivot ought to be > lowest value of subset & < largest one)
		: "=m"(sum), [mean]"=m"(mean) // [pvtCor]"=m"(GV0.pivotCorrection)//output
		://input
		://clobbered
		 );
			if(sum != 0){
			  if((minNorm > mean || maxNorm < mean) && kind0fVals!=3)
			pv1:                   return get_pivotVerI();// mid exponent doesn't work anymore, thereby we count mid significand
		}
			  
	 //////////////////////////// compute middle element //////////////////
	/* __asm__ (
		"restore_esp:               ;\n\t"
		"popq %%rbx; \n\t"
		"popq %%rsi; \n\t"
		"popq %%rdi; \n\t"
		"movq %[esp], %%rsp; \n\t"
		"movq %[ebp], %%rbp; \n\t"
		"movq $1, %%rax; \n\t"
		"jmp init0    ; \n\t"
    	: [esp]"=m"(adrLR.ESP), [ebp]"=m"(adrLR.EBP)     //output
		:                         //input
		:                        //clobbered
		 );*/
		 return 1;
}


int adjust_pvt_stub(){
	__asm__ (
	     "movq $1, %%rax; \n\t"
		 "popq %%rbp; \n\t"
		 "retq; \n\t"
		://output
		:  //input
		: //clobbered
	);
	}
//get_pivotVerII
	int IsArrSorted_fastVer(double *arr, double *end){
	end++;
		__asm__ (
	    // "pxor %%xmm7, %%xmm7         ; \n\t"
		 "xorq %%rdi, %%rdi            ; \n\t"
		 "not %%rdi                    ; \n\t"
		 "mov  %[arr], %%rsi          ; \n\t"
		 "movq %[end], %%rcx          ; \n\t"
		 "movq (%%rsi), %%xmm1        ; \n\t"
		 "rollIt:                     ; \n\t"
		 "add $8, %%rsi               ; \n\t"
		 "movq (%%rsi), %%xmm2        ; \n\t"
		 "cmpsd $1, %%xmm2, %%xmm1    ; \n\t"
		 "movq %%xmm1, %%rax          ; \n\t"
		 "not %%rax                   ; \n\t"
		 //"and $1, %%rax               ; \n\t"
		 "cmp %%rax, %%rdi            ; \n\t"
		 "jne ready                    ; \n\t"
		 "pshufd $0x44, %%xmm2, %%xmm1; \n\t"
		 "cmp %%rcx, %%rsi            ; \n\t"
		 "jb rollIt                   ; \n\t"
		 "ready:                      ; \n\t"
		 "popq %%rbp                  ; \n\t"
		 "retq                         ; \n\t"
		:[arr]"=m"(arr), [end]"=m"(end) //output
		:                              //input
		:                             //clobbered
	);	
	}
	int IsArrSorted(double *arr, double *end){
		arr++;
		end++;
	for(; arr<end; arr++){
		if(*arr==*(arr-1))continue;
		if(*arr < *(arr-1))continue;
		else{
		 __asm__ (
		 "ias0:    ;\n\t"
		://output
		://input
		://clobbered
		 );	
		return 0;
		}
		 __asm__ (
		 "ias:    ;\n\t"
		://output
		://input
		://clobbered
		 );
		return 1;
	}
}
int64_t register flgR   asm("r15");
int64_t register flgL   asm("r14");
int64_t register flgSWP asm("r13");
int  __attribute__((aligned(4))) 
fastsort(double *fst, double *lst, int pivot=1){
		if(fst==lst)return 0;
	/*	if(!GV0.swtch){
			GV0.swtch=true;
			goto Strt;
		} else GV0.swtch=false;*/
     // if(IsArrSorted_fastVer(fst, lst))return 0;
     __asm__ (
		// "not %%rdi                    ; \n\t"
		 /*"jmp cache_align0            ; \n\t"
		 "nop                         ; \n\t"
		 "nop                         ; \n\t"
		 "xorq %%rax, %%rax           ; \n\t"
		 "xorq %%rax, %%rax           ; \n\t"
		 "xorq %%rax, %%rax           ; \n\t"
		 "cache_align0:               ; \n\t"//*/
		 "mov $16640, %%rdi            ; \n\t"
		 "mov  %[arr], %%rsi          ; \n\t"
		 "movq %[end], %%rcx          ; \n\t"
		 "rollIt0:                     ; \n\t"
		 "add $8, %%rsi               ; \n\t"
		 "movq (%%rsi), %%xmm2        ; \n\t"
		 //"cmpsd $2, -0x8(%%rsi), %%xmm2    ; \n\t"
		 "comisd -0x8(%%rsi), %%xmm2; \n\t"//test xmm2 > xmm1 
		"lahf; \n\t"// dumps flags to eax 
		"andq %%rdi, %%rax; \n\t"//gets CF (carry) flag. If CF==1 -- xmm2 > xmm1*/
		//"movq %%xmm2, %%rax            ; \n\t"
		 //"not %%rax                    ; \n\t"
		 /*"jnc else                  ; \n\t"
		 "jc continue                ; \n\t"//*/
		 "jz continue             ; \n\t"
		 "else:                    ; \n\t"
		// "pshufd $0x44, %%xmm2, %%xmm1; \n\t"
		 "cmp %%rcx, %%rsi            ; \n\t"
		 "jb rollIt0                   ; \n\t"
		 "jmp ready0                  ; \n\t"
		 "continue:                   ; \n\t"
	     "movq -0x8(%%rsi), %%xmm1        ; \n\t"
		 "movq %%xmm1,   (%%rsi)      ; \n\t"
		 "movq %%xmm2, -0x8(%%rsi)    ; \n\t"
		:[arr]"=m"(fst), [end]"=m"(lst) //output
		:                              //input
		:                             //clobbered
	);	// */
	// if(IsArrSorted_fastVer(fst, lst))return 0;
	Strt:
		
	//	GV0.depth++;
		/*adrLR.nas[1]=&nas_stub;
		adrLR.nas[0]=&nas_stub;
		adrLR.loadL[0]=&load_L_once;
		adrLR.loadL[1]=&load_stub;
		adrLR.loadR[0]=&load_R_once;
		adrLR.loadR[1]=&load_stub;
		GV0.fsort[1]=&fastsort;
		if(adrLR.fst == fst)GV0.fsort[0]=&fsortL_stub;
		else GV0.fsort[0]=&fsortR_stub;*/
		// consts.rnd = rand() % consts.range + 1;
		//adrLR.fst=fst;
		//adrLR.lst=lst;
		adrLRlst0=fst;
		adrLRfst0=lst;
		//partiallyOrdering(0, 0);
		//flgL=0; // flag to xmm1<=xmm4
		//flgR=0; // flag to xmm2>=xmm4
		flgSWP=0; //GV0.flgSWP=0; // flag to xmm1<=xmm4<=xmm2
		//adrLR.LNotSorted=0; // flags to indicate whether left/right subset of array gets sorted or not
		//adrLR.RNotSorted=0;
		//int LNotSorted;
		//int RNotSorted;
		/*__asm__ (
		"store_ebp:               ;\n\t"
		"movq %%rbp, %[ebp]; \n\t"
		"movq %%rsp, %[esp]; \n\t"
		: [ebp]"=m"(adrLR.EBP), [esp]"=m"(adrLR.ESP)     //output
		:                         //input
		:                        //clobbered
		 );*/
		pivot=(adrLR.getpivot[pivot])();
		 __asm__ (
		 "init0:    ;\n\t"
		://output
		://input
		://clobbered
		 );
		 
		 __asm__ (
		 "movq %[fst], %%rax; \n\t"
		 "movq %[lst], %%rdx; \n\t"
		 //"movq  $l11,  %%r15; \n\t"
                   "movq (%%rax), %%xmm1; \n\t"
	          "leaq %[base], %%r11; \n\t"
		 "movq (%%rdx), %%xmm2; \n\t"
		 "mov  $8,   %%r10; \n\t"//const to add
		"mov  $1,   %%r12; \n\t"//const to add
		 "mov  $10,   %%r14; \n\t"//adrLR.swp
		 //"prefetcht0 (%%r15)   ; \n\t"
		 "l11:                ; \n\t"
		 //"PSHUFD $0xE4, %%xmm1, %%xmm0; \n\t"
		 //"PSHUFD $0xE4, %%xmm2, %%xmm3; \n\t"
		:[fst]"=m"(fst), [lst]"=m"(lst), [base]"=m"(adrLR)//output
		://input
		://clobbered
		 );
		//for(; adrLRlst0 < adrLRfst0;){
		//adrLR.cnt++;
			__asm__ (
		 "cmp:             ; \n\t"
		 "mov %%r14, %%r13; \n\t" // initialize flgSWP
		/* "xorq %%rcx, %%rcx; \n\t"
		 "xorq %%rbx, %%rbx; \n\t"
		 "xorq %%rsi, %%rsi; \n\t"//*/
		 "comisd %%xmm2, %%xmm1; \n\t"//test xmm2 > xmm1 
		 "jnc cf2rcx       ; \n\t"
		 "add $4, %%r13    ; \n\t"
		// "mov $1, %%rcx    ; \n\t"
		 "cf2rcx:          ; \n\t"//*/
		 "xorq %%rdi, %%rdi; \n\t"//*/
		 "comisd %%xmm4, %%xmm1; \n\t"
		 "jnc cf2rdi       ; \n\t"
		 "add %%r12, %%r13    ; \n\t"
		// "jmp zf2rax       ; \n\t"
		 "cf2rdi:          ; \n\t"
		 /*"jnz zf2rax       ; \n\t"
		 "mov $1, %%rax    ; \n\t"
		 "zf2rax:          ; \n\t"//*/
		 "comisd %%xmm2, %%xmm4; \n\t"//test xmm2 > xmm4 (xmm4 is pivot)
		 "jnc cf2rbx       ; \n\t"
		"add $2, %%r13    ; \n\t"
		// "mov $1, %%rbx    ; \n\t"
		
		 //"jmp zf2rsi     ; \n\t"
		 "cf2rbx:          ; \n\t"
		 /*"jnz zf2rsi       ; \n\t"
		 "mov %%r12, %%rsi    ; \n\t"
		 //"mov $1, %%rsi    ; \n\t"
		 "zf2rsi:          ; \n\t"//*/
		//"and %%rdi, %%rsi; \n\t"//CF(Left/Right) AND ZF(R/L)
		 //"and %%rbx, %%rax; \n\t"
		 //"or  %%rax, %%rdi; \n\t"//ZF(L/R) OR CF(L/R)
		 //"or  %%rsi, %%rbx; \n\t"
		 //"add %%rbx, %%r13; \n\t"// forms flgSWP
		 //"and %%rdi, %%r13; \n\t"
		 /*"or  %%rcx, %%r13; \n\t"//finishes to form flgSWP
		 "add  %%rbx,   %%rbx; \n\t"//rax is flgL, rbx is flgR, r13 is flgSWP
		 "shl  $2, %%r13; \n\t"//*/
		 //"add  %%r13,   %%r13; \n\t"
		 //"or  %%rdi,  %%rbx; \n\t"
		 //"or  %%rbx,  %%r13; \n\t"//now, we got switcher(r13), it consists of three flags (SWP|R|L, L is the least bit)
	          "next_run:        ; \n\t"
		 //"add %%r14,  %%r13; \n\t"
		 "mov (%%r11, %%r13, 8), %%r13; \n\t"
		 "call *%%r13       ; \n\t"
		 "cmp   %%r8, %%r9  ; \n\t"
		 "ja cmp            ; \n\t"
		:// "=r"(flgSWP)//output
		:  //input
		: //clobbered
	);
	//(adrLR.swp[flgSWP])();//swap o/& load
	//}
	 /*__asm__ (
		 "ns: pcmpeqd %%mm7, %%mm7; \n\t"//0xFF(8)
		 "psllq $1, %%mm7;\n\t"//initialize the mask to get 1st bit 0xFF(7) FE
		 "por %%mm7, %%mm1 \n\t"//if flag ==0,0xFF(7) FE; if flag==1, 0xFF(8)
		 "por %%mm7, %%mm2 \n\t"//if flag ==0,0xFF(7) FE; if flag==1, 0xFF(8)
		 "pxor %%mm7, %%mm1 \n\t"//gets 1st bit to form LNotSorted
		 "pxor %%mm7, %%mm2 \n\t"//gets 1st bit to form RNotSorted
		 //puts flags in ram
		 "movq %%mm1, %0 \n\t"// 
		 "movq %%mm2, %1; \n\t"// 
		: "=m"(adrLR.LNotSorted), "=m"(adrLR.RNotSorted) //output
		:                      //input
		: //clobbered
	);*/
//	adrLRfst0+=1; // make bounds between left & right subsets
	double *lst0=adrLRlst0;
	double *fst0=adrLRfst0;
	//if(lst==lst0 || fst==fst0)adjust_pvt();
	if(fst+1==lst)return 0; 
	if(lst == lst0)lst0--;
	//if(lst-fst0>10000)pivot=1;
	//else pivot=0;
//	RNotSorted=adrLR.RNotSorted;
	//LNotSorted=adrLR.LNotSorted;
	fastsort(fst0, lst, pivot);
	//if(lst0-fst>10000)pivot=1;
	//else pivot=0;
	fastsort(fst, lst0, pivot);
	//GV0.depth--;
	 __asm__ (
		 "ready0:    ;\n\t"
		://output
		://input
		://clobbered
		 );
		return 0;}
		
int fastsort_prime(double *fst, double *lst, int pivot=1){
		if(fst==lst)return 0; 
		adrLR.cnt++;
		//GV0.depth=1;
		//GV0.swtch=false;
	    SWAPS swp[2];
		//LOADS loadL[2], loadR[2];
		
		NAS nas[2];
		
		//GV0.swp=&xorswap;
		adrLR.swp[1]=&load_R; //001b(SWP|R|L)
		adrLR.swp[2]=&load_L; //010b
		adrLR.swp[5]=&swpnLR; //101b
		adrLR.swp[6]=&swpnLL; //110b
                 adrLR.swp[7]=&xorswap;//111b
		adrLR.swp[0]=&ok;     //000b -- don't swap, just load new left & right items
		GV0.fsort[1]=&fastsort;
		if(adrLR.fst == fst)GV0.fsort[0]=&fsortL_stub;
		else GV0.fsort[0]=&fsortR_stub;
		adrLR.getpivot[2]=&pivot_rnd;
		adrLR.getpivot[1]=&get_pivotVerII;
		adrLR.getpivot[0]=&get_pivotVerI;
		//adrLR.getpivot[2]=&pivot_rnd;
		//GV0.adj_pvt[0]=&adjust_pvt;
		//GV0.adj_pvt[1]=&adjust_pvt_stub;
		adrLRlst0=fst;
		adrLRfst0=lst;
		adrLR.fst=fst;
		adrLR.lst=lst;
		/*partiallyOrdering(0, 0);
		partiallyOrdering(1, 0);
		partiallyOrdering(0, 1);*/
		flgL=0; // flag to xmm1<=xmm4
		flgR=0; // flag to xmm2>=xmm4
		flgSWP=0; // flag to xmm1<=xmm4<=xmm2
		adrLR.LNotSorted=0; // flags to indicate whether left/right subset of array gets sorted or not
		adrLR.RNotSorted=0;
		int LNotSorted;
		int RNotSorted;
		/*__asm__ (
		"stor1_ebp:               ;\n\t"
		"movq %%rbp, %[ebp]; \n\t"
		"movq %%rsp, %[esp]; \n\t"
		: [ebp]"=m"(adrLR.EBP), [esp]"=m"(adrLR.ESP)     //output
		:                         //input
		:                        //clobbered
		 );*/
		__asm__ (
		 "init1:    ;\n\t"
		://output
		://input
		://clobbered
		 );
		 __asm__ (
		 "movq  $2, %%r11; \n\t"
		 "movq %%r11, %%xmm13; \n\t"
		 "CVTDQ2PD %%xmm13, %%xmm13; \n\t"//const "2.0"
		 "movq %[fst], %%rax; \n\t"
		 "movq %[lst], %%rdx; \n\t"
		 "pxor %%xmm4, %%xmm4; \n\t"
         "movq (%%rax), %%xmm1; \n\t"
		 "movq (%%rdx), %%xmm2; \n\t"
		 "mov  $8,   %%r10; \n\t"
		 "l00:                ; \n\t"
		 "PSHUFD $0xE4, %%xmm1, %%xmm0; \n\t"
		 "PSHUFD $0xE4, %%xmm2, %%xmm3; \n\t"
		:[fst]"=m"(fst), [lst]"=m"(lst)//output
		://input
		://clobbered
		 );
		for(; adrLRlst0 < adrLRfst0;){
			__asm__ (
		 "cmp0: xorq %%rax, %%rax; \n\t"
		 "xorq %%rdx, %%rdx; \n\t" // initialize flgSWP
      	 "comisd %%xmm2, %%xmm4; \n\t"//test xmm2 > xmm4 (xmm4 is pivot)
		 "lahf; \n\t"// dumps flags to eax 
		 "shrq $0x8, %%rax; \n\t"//gets CF flag. If CF==1 -- xmm2 > xmm4
		 "and $0x1, %%rax; \n\t"//now, we get flgR 
		 "xorq %%rax, %%rdx; \n\t"// forms flgSWP
		 "mov  %%rax, %%rbx; \n\t"//stores flgR to ebx
		 "xorq %%rax, %%rax; \n\t"
		 "comisd %%xmm4, %%xmm1; \n\t"
		 "lahf; \n\t"
		 "shrq $0x8, %%rax; \n\t"
		 "and $0x1, %%rax; \n\t"
		 "and %%rax, %%rdx; \n\t"//finishes to form flgSWP
		 "shl   $1,   %%rbx; \n\t"//rax is flgL, rbx is flgR, rdx is flgSWP
		 "add  %%rdx, %%rdx; \n\t"
		 "shl   $1,   %%rdx; \n\t"
		 "or  %%rax,  %%rbx; \n\t"
		 "or  %%rbx,  %%rdx; \n\t"//now, we got switcher(rdx), it consists of three flags (SWP|R|L, L is the least bit) 
		 "mov  %%rbx, %0; \n\t"
		 "mov  %%rax, %1; \n\t"
		 "mov  %%rdx, %2; \n\t"
		: "=r"(flgR), "=r"(flgL), "=r"(flgSWP)//output
		:  //input
		: //clobbered
	);
	(adrLR.swp[flgSWP])();//swap o/& load
	}
	 /*__asm__ (
		 "ns0: pcmpeqd %%mm7, %%mm7; \n\t"//0xFF(8)
		 "psllq $1, %%mm7;\n\t"//initialize the mask to get 1st bit 0xFF(7) FE
		 "por %%mm7, %%mm1 \n\t"//if flag ==0,0xFF(7) FE; if flag==1, 0xFF(8)
		 "por %%mm7, %%mm2 \n\t"//if flag ==0,0xFF(7) FE; if flag==1, 0xFF(8)
		 "pxor %%mm7, %%mm1 \n\t"//gets 1st bit to form LNotSorted
		 "pxor %%mm7, %%mm2 \n\t"//gets 1st bit to form RNotSorted
		 //puts flags in ram
		 "movq %%mm1, %0 \n\t"// 
		 "movq %%mm2, %1; \n\t"// 
		: "=m"(adrLR.LNotSorted), "=m"(adrLR.RNotSorted) //output
		:                      //input
		: //clobbered
	);*/
//	adrLRfst0+=1; // make bounds between left & right subsets
	double *lst0=adrLRlst0;
	double *fst0=adrLRfst0;
	/* __asm__ (
		 "movq %[fst], %%rax; \n\t"
		 "movq %[lst], %%rsi;\n\t"
		 "mov 4(%%rax), %%rdx; \n\t"
		 "mov 4(%%rsi), %%rdi; \n\t"
		 "shrq $28, %%rdx; \n\t"
		 "shrq $28, %%rdi; \n\t"
		 "subl %%rdi, %%rsi; \n\t"
		 "not %%rdx; \n\t"
		 "and $8, %%rdx; \n\t"
		 "addl %%rdx, %%rax; \n\t"
		 "mov  %%rax, %[fst]; \n\t"
		 "mov  %%rsi, %[lst]; \n\t"
		: [fst]"=m"(fst0), [lst]"=m"(lst0) //output
		:                      //input
		: //clobbered
	);*/
		//fst0+=(*fst0 < 0.0);
		//lst0-=(*lst0 > 0.0);

	RNotSorted=adrLR.RNotSorted;
	LNotSorted=adrLR.LNotSorted;
	adrLR.wing='R';
__asm__ (
		 "rootR:    ;\n\t"
		/* "movq (%%rax), %%xmm1;\n\t"
		 "psrlq $63, %%xmm1   ;\n\t"
		 "movq %%xmm1, %%rdx  ;\n\t"
		 "shl $3, %%rdx       ;\n\t"
		 "sub %%rdx, %%rax    ;\n\t"
		 "mov  %%rax, %[lst]  ;\n\t"*/
		://[lst]"=m"(lst)//output
		: //"a"(lst)//input
		://clobbered
		 );
		 //if(*lst<0)lst--;
	(GV0.fsort[/*RNotSorted*/1])(fst0, lst, 1);
	adrLR.wing='L';
__asm__ (
		 "rootL:    ;\n\t"
		://output
		://input
		://clobbered
		 );
	(GV0.fsort[/*LNotSorted*/1])(fst, lst0, 1);
	__asm__ (
		 "exit0:    ;\n\t"
		://output
		://input
		://clobbered
		 );
		/* *lst0=*lst;
		 *lst=*(lst-1);
		 *(lst-1)=*lst0;*/
		return 0;}
/*********************** NO-IF QSort-based ****************************/
static int compare (const void * a, const void * b){
    if (*(const double*)a < *(const double*)b) return 1;
    else if (*(const double*)a > *(const double*)b) return -1;
    else return 0;  
}
int comp(const void* a, const void* b)
{
  const int64_t* lhs = (const int64_t*)a;
  const int64_t* rhs = (const int64_t*)b;
  return lhs - rhs;
}

void IsArrSorted(double *arr, int I){
	bool bOrder, bWellOrdered;
	bWellOrdered=true;
	int i=1;
	while(arr[i]==arr[i-1])i++;
	if(arr[i]>arr[i-1]){
		for(; i<I; i++){
			if(arr[i]==arr[i-1])continue;
			if(arr[i]<arr[i-1]){
				bWellOrdered=false;
				goto retq;
			}
		}
			bOrder=false;
			goto retq;
	}
	bWellOrdered=true;
	for(; i<I; i++){
		if(arr[i]==arr[i-1])continue;
		if(arr[i]>arr[i-1]){
			bWellOrdered=false;
			break;
		}
	}
	if(bWellOrdered)bOrder=true;
retq: if(bWellOrdered){
		if(!bOrder)printf("\n\nAscending Order\n\n");
		else printf("\n\nDescending Order\n\n");
	 }  else printf("\n\nNot Ordered at %d\n\n", i);
	 return;
}
/*********************** HeapSort ********************************/

inline void swap(double *a, int first, int second)
{
	int64_t tmp;
	tmp=a[first];
	a[first]=a[second];
	a[second]=tmp;
	return;
}
extern inline void siftDown_c(double *a, int root, int end);
inline void siftDown_c(double *a, int root, int end){
	int child=2*root+1, indx;
	while(child+1<end){
		//if(child+1<end){
		indx=child+1;
			if(a[child]<a[child+1])child++;
		//}
		if(a[root]<a[child]){
			swap(a, root, child);
		    root=child;
		}else
          return;
		child=2*root+1;
	}
	if(child<end){
	/*	if(child+1==end){
			if(a[child]<a[child+1])child++;
		}*/
			if(a[root]<a[child]){
			swap(a, root, child);
		    root=child;
		}
		}
}
extern inline void Heapify_c(double *a, int end);
inline void Heapify_c(double *a, int end)
{
	int root=(end-1)/2;
	while(!(root<0)){
		siftDown_c(a, root--, end-1);
	}
}
void heapSort_c(double *arr, int end){
 Heapify_c(arr, end);
 while(end>0)
 {
	 swap(arr, 0, end-1);
	 siftDown_c(arr, 0, end-1);
	 end--;
 }
}
/***********************
 HeapSort 
************************/
/****************** main ******************/

int main(int argc, char* argv[])
{
  printf("© 2013-2014 Evgeney Knyazhev.\n\n");
  int size0fInt = sizeof(double);
  int N0fItems = 10;
  int bottom = 0;
  int DownThe;
  int UpThe = 1;
  int rnd_pvt=2;
  int64_t deltaV;
  double *array2sort;
  double *unsortedArr;
  double *lst;
  int64_t *p0;
  int64_t *p1;
  adrLR.cnt=0;
  pEmpty=&empty;
  char StopThe = 0;
  char GV;        /*greater value*/
  char unit = 0;
  pEmpty = &empty;
  chosenT seed = 583613;
  chosenT exp = 286661143;
  chosenT mod = 9147736951;
  chosenT countIteration;
  struct constants *znt;
  znt=&consts;
  znt->fffffffffffffff8= 0xfffffffffffffff8;
  znt->ffffffff00000000= 0xffffffff00000000;
  znt->h00000000000007ff=0x00000000000007ff;
  znt->h000fffffffffffff=0x000fffffffffffff;
  znt->range=1024LL*1024LL*1024LL;
  //consts
  char *fstPoint0fSeg_Char;// initial point of segment for metamorphic code
  LOADS fp0;
  LOADS fp1;
  struct sigaction sa;
  sa.sa_flags = SA_SIGINFO;
  sigemptyset(&sa.sa_mask);
  sa.sa_sigaction = handler;
w:  if (sigaction(SIGSEGV, &sa, NULL) == -1)
                        handle_error("sigaction");

  fp0=get_pivotVerII;
  fp1=get_pivotVerI;
  int64_t pagesize;
  int64_t fstPoint0fSeg; //segment of get_pivotVerII to allow it to be writable
  int64_t lstPoint0fSeg;
  
  pagesize = sysconf(_SC_PAGE_SIZE);
  if (pagesize == -1)
			 handle_error("sysconf");
   __asm__ (
		
		"mv: movq %%xmm0, %%xmm0; \n\t"
		"movq %%rax, %0; \n\t"
		"movq %%rdx, %1; \n\t"
		:"=m"(fstPoint0fSeg), "=m"(lstPoint0fSeg)//output
		:"a"(fp0), "d"(fp1)//input
		://clobbered
	);
	//gets first point of segment aligned by pagesize
fstP:fstPoint0fSeg/=pagesize;
	 fstPoint0fSeg*=pagesize;
	//gets first point of segment aligned by pagesize
	lstPoint0fSeg-=fstPoint0fSeg;//distance between function entry, aligned by pagesize, & the end of function
	//gets last point of segment aligned by pagesize
	 lstPoint0fSeg/=pagesize;
	 lstPoint0fSeg*=pagesize;
	 lstPoint0fSeg++;
	//gets last point of segment aligned by pagesize
	 __asm__ (
		
		"mv1: movq %%xmm0, %%xmm0; \n\t"
		"movq %%rax, %0; \n\t"
		:"=m"(fstPoint0fSeg_Char)//output
		:"a"(fstPoint0fSeg)//input
		://clobbered
	);
	 if (mprotect(fstPoint0fSeg_Char, lstPoint0fSeg,
                       PROT_READ|PROT_WRITE|PROT_EXEC) == -1)
               handle_error("mprotect");
///////////////// set stack's size
  const rlim_t kStackSize = 16L * 1024L * 1024L;   // min stack size = 64 Mb
    struct rlimit rl;
    int result;

    result = getrlimit(RLIMIT_STACK, &rl);
    if (result == 0)
    {
        if (rl.rlim_cur < kStackSize)
        {
			//printf("Previuos stack size: %d\n", rl.rlim_cur);
            rl.rlim_cur = kStackSize;
            result = setrlimit(RLIMIT_STACK, &rl);
            if (result != 0)
            {
                fprintf(stderr, "setrlimit returned result = %d\n", result);
            }
        }
	}
///////////////// set stack's size
 printf("Set the seed, please: ");
 scanf("%d", &seed);
 printf("Set the size of array, please: ");
 scanf("%d", &N0fItems); 
//  printf("Set value to correct pivot(double val -- xx.xxx), please: ");
 //scanf("%lf", &GV0.pivotCorrection); 
  array2sort = (double*)malloc(N0fItems * size0fInt+16);
  unsortedArr = (double*)malloc(N0fItems * size0fInt+16);
  if(array2sort == NULL || unsortedArr == NULL)
  {
    printf("Not enough memory for array\n");
    return 0;
  }
  srand (time(NULL)*seed);
  array2sort=(double*)((unsigned int64_t)(array2sort+15) & (~0xfLL));
  unsortedArr=(double*)((unsigned int64_t)(unsortedArr+15) & (~0xfLL));
  adrLR.arr=array2sort;
  adrLR.parr=unsortedArr;
  pseudoRND_fast((int64_t*)array2sort, N0fItems, mod, seed, exp);
  for(unsigned int p = 0; p < (unsigned)N0fItems; p++)
    unsortedArr[p]=array2sort[p];
  DownThe = N0fItems - 1;
  countIteration = 0;
  bottom = 0;
  StopThe = 0;
  clock_t start, stop;
 
 /*for(unsigned int p = 0; p < (unsigned)N0fItems; p++)
    array2sort[p] = unsortedArr[p];
 printf("Qsort routine from Bentley & McIlroy's Engineering a Sort Function\n");
  start = clock();
  lst=array2sort+N0fItems-1;
 //qs0(array2sort, N0fItems, sizeof(double), compare);;
 stop = clock();
 printf("Qsort routine from Bentley & McIlroy's Engineering a Sort Function : %ld ticks (%1f msec)\n", stop-start, (1000.0*
(stop-start)/CLOCKS_PER_SEC));
 IsArrSorted(array2sort, N0fItems);
/* printf("Start Heapsort_c\n");
  start = clock();
 heapSort_c(array2sort,N0fItems);
 stop = clock();
 printf("Heapsort_c: %ld ticks (%f msec)\n", stop-start, (1000.0*
(stop-start)/CLOCKS_PER_SEC));
IsArrSorted(array2sort, N0fItems);*/

 // for(unsigned int p = 0; p < (unsigned)N0fItems; p++)
   // array2sort[p] = unsortedArr[p];

  printf("\nStart qsort\n");
  start = clock();
  qsort(unsortedArr, N0fItems, sizeof(double), compare);
  stop = clock();
  printf("\nqsort: %ld ticks (%f msec)\n", stop-start, (1000.0*(stop-start)/
CLOCKS_PER_SEC));
//IsArrSorted(array2sort, N0fItems);
 printf("\nStart No-IF fastsort\n");
  start = clock();
  lst=array2sort+N0fItems-1;
 countIteration = fastsort_prime(array2sort,lst, 1);
 stop = clock();
// printf("\nNo-IF fastsort: %ld ticks (%1f msec)\nNumber of recursions: %d\n", stop-start, (1000.0*
//(stop-start)/CLOCKS_PER_SEC), adrLR.cnt);
printf("\nNo-IF fastsort: %ld ticks (%1f msec)\n", stop-start, (1000.0*
(stop-start)/CLOCKS_PER_SEC));
 IsArrSorted(array2sort, N0fItems);
/* uint64_t p01=(uint64_t)N0fItems-1;
 double tmp01;
 double tmp02;
  for(uint64_t p02 = 0; p02 < p01; p02++){
    p01-=p02;
	tmp01=unsortedArr[p01];
	tmp02=unsortedArr[p02];
	unsortedArr[p01]=tmp02;
	unsortedArr[p02]=tmp01;
	 }*/
	
 __asm__ (
		 "vrfy:    ;\n\t"
		://output
		://input
		://clobbered
		 );
 for(uint64_t p = 0; p < (uint64_t)N0fItems; p++){
	 if(array2sort[p] != unsortedArr[p]){
		 printf("\nArray got corrupted\n");
		 __asm__ (
		 "mainFin0:    ;\n\t"
		://output
		://input
		://clobbered
		 );
		 return 0;
	 }
	
 }
__asm__ (
		 "mainFin1:    ;\n\t"
		://output
		://input
		://clobbered
		 );
  printf("Everything is ok\n");
 /* start = clock();
  std::sort(array2sort, array2sort+N0fItems);
  stop = clock();
  printf("sort: %ld ticks (%f msec)\n", stop-start, (1000.0*(stop-
start)/CLOCKS_PER_SEC));

 /* for(unsigned int p = 0; p < (unsigned)N0fItems; p++)
    array2sort[p] = unsortedArr[p];
  printf("Start make_heap + sort_heap\n");
  start = clock();
  std::make_heap(array2sort, compare, N0fItems);
  sort_heap(array2sort, compare, N0fItems);
  stop = clock();
  printf("make_heap + sort_heap: %ld ticks (%f msec)\n", stop-
start, (1000.0*(stop-start)/CLOCKS_PER_SEC));
  IsArrSorted(array2sort, N0fItems);*/
  
  //for(unsigned int p = 0; p < (unsigned)N0fItems; p++)
    //array2sort[p] = unsortedArr[p];
  return 0;
}

